unit AdminBackup;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls,
  InstanceSections, AdditionalClasses,
  ImgList, Buttons, Contnrs, Menus, ApplicationDataModule, AuxFuncs,
  myx_public_interface, myx_admin_public_interface, SchemataTreeView,
  AdvancedEdit, PNGImage,
  AdminBackupProgress, AuxAdminBackupRestore,
  InstanceDataModule, Options, MyxError;

type
  TBackupThread = class;

  TAdminBackupForm = class(TInstanceSectionForm)
    ServerBackupRestorePnl: TPanel;
    BackupRestorePageControl: TPageControl;
    BackupContentTabSheet: TTabSheet;
    ItemSelectImageList: TImageList;
    Panel1: TPanel;
    RestoreBevel: TBevel;
    Label3: TLabel;
    Backup2Img: TImage;
    SubTreePnl: TPanel;
    BackupTreeViewPopupMenu: TPopupMenu;
    RemoveBackupNodeMI: TMenuItem;
    ProfilesPopupMenu: TPopupMenu;
    RefreshProfilesMI: TMenuItem;
    SchemataFrame: TSchemataFrame;
    ContentSplitter: TSplitter;
    Panel2: TPanel;
    TopPnl: TPanel;
    SchemataLbl: TLabel;
    AdvancedEditFrame: TAdvancedEditFrame;
    SpacerPnl: TPanel;
    ProjectListView: TListView;
    AddSchemaToBackupBtn: TButton;
    RemoveSchemaFromBackup: TButton;
    Panel3: TPanel;
    BackupTreeView: TTreeView;
    BackupTreeViewHeaderControl: THeaderControl;
    Panel4: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Panel7: TPanel;
    N1: TMenuItem;
    ChangeProfilesDirMI: TMenuItem;
    DeleteProfileMI: TMenuItem;
    ClearCompleteContentMI: TMenuItem;
    AdvancedOptionsTabSheet: TTabSheet;
    Panel5: TPanel;
    Bevel1: TBevel;
    Label15: TLabel;
    Backup3Img: TImage;
    Label16: TLabel;
    NewProjectBtn: TButton;
    ApplyBtn: TButton;
    StartBackupBtn: TButton;
    Panel9: TPanel;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    ProjectNameEd: TEdit;
    ScheduleTabSheet: TTabSheet;
    ScheduleGBox: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label27: TLabel;
    TargetDirEd: TEdit;
    BrowseTargetDirBtn: TButton;
    FilenamePrefixEd: TEdit;
    CheckBox1: TCheckBox;
    Panel6: TPanel;
    BackupBevel: TBevel;
    Label6: TLabel;
    BackupImg: TImage;
    Label7: TLabel;
    ExecutionTimeGBox: TGroupBox;
    SchedulePageControl: TPageControl;
    DailyTabSheet: TTabSheet;
    Label26: TLabel;
    WeeklyTabSheet: TTabSheet;
    Label21: TLabel;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox7: TCheckBox;
    TabSheet3: TTabSheet;
    Label22: TLabel;
    Label20: TLabel;
    Label25: TLabel;
    ComboBox1: TComboBox;
    Panel8: TPanel;
    Label23: TLabel;
    Label24: TLabel;
    Edit1: TEdit;
    ComboBox2: TComboBox;
    Panel10: TPanel;
    AdvOptionsScrollBox: TScrollBox;
    GroupBox3: TGroupBox;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label14: TLabel;
    LockAllTablesRButton: TRadioButton;
    SingleTransRButton: TRadioButton;
    RadioButton3: TRadioButton;
    CompleteSchematasCBox: TCheckBox;
    GroupBox2: TGroupBox;
    Label12: TLabel;
    Label13: TLabel;
    NoCreatesCBox: TCheckBox;
    NoExtendedInsertsCBox: TCheckBox;
    AddDropTableCBox: TCheckBox;
    CompleteInsertsCBox: TCheckBox;
    CommentCBox: TCheckBox;
    FullPathCBox: TCheckBox;
    AnsiQuotesCBox: TCheckBox;
    DisableKeysCBox: TCheckBox;
    BackupFileTypesLU: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure RefreshSchemaTree(searchStr: String = '');
    procedure ServerBackupRestorePnlResize(Sender: TObject);
    procedure BackupTreeViewAdvancedCustomDrawItem(Sender: TCustomTreeView;
      Node: TTreeNode; State: TCustomDrawState; Stage: TCustomDrawStage;
      var PaintImages, DefaultDraw: Boolean);
    procedure BackupTreeViewMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure BackupTreeViewHeaderControlSectionResize(
      HeaderControl: THeaderControl; Section: THeaderSection);

    procedure AddSchemaToBackupBtnClick(Sender: TObject);
    procedure AddSchemaToBackup(Schema: TMYX_SCHEMA; Selected: Boolean = True);
    procedure BackupTreeViewDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure BackupTreeViewDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure SchemaTreeViewExpanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure BackupTreeViewPopupMenuPopup(Sender: TObject);
    procedure RemoveBackupNodeMIClick(Sender: TObject);

    procedure RemoveTreeNode(Node: TTreeNode);
    procedure SchemaTreeViewCollapsing(Sender: TObject; Node: TTreeNode;
      var AllowCollapse: Boolean);
    procedure SchemataFrameSchemaTreeViewMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SchemataFrameSchemaTreeViewMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure StartBackupBtnClick(Sender: TObject);

    procedure NewProjectBtnClick(Sender: TObject);
    procedure BackupTreeViewChanging(Sender: TObject; Node: TTreeNode;
      var AllowChange: Boolean);
    procedure ClearControls(EnableControls: Boolean);
    procedure ProjectNameEdExit(Sender: TObject);
    procedure BrowseTargetDirBtnClick(Sender: TObject);
    procedure DoChange(Sender: TObject);
    procedure DiscardBtnClick(Sender: TObject);
    procedure ApplyBtnClick(Sender: TObject);

    procedure RefreshBackupProfiles(SelectProfile: string = '');

    procedure ApplyChanges;
    procedure DiscardChanges(AskBeforeDiscard: Boolean);

    procedure LoadProfile(filename: string);
    function GetSelectedTablesCount: integer;

    function GetOptions: integer;
    procedure AddOption(var options: integer;
      option: MYX_BACKUP_OPTIONS; Add: Boolean);
    function InOptions(options: integer; option: MYX_BACKUP_OPTIONS): Boolean;
    procedure RefreshProfilesMIClick(Sender: TObject);
    procedure ProjectListViewEdited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure DeleteProfileMIClick(Sender: TObject);
    procedure ProfilesPopupMenuPopup(Sender: TObject);
    procedure ClearCompleteContentMIClick(Sender: TObject);
    procedure ProjectListViewSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);

    procedure Disconnected(var Message: TMessage); message WM_Disconnected;
    procedure Reconnected(var Message: TMessage); message WM_Reconnected;
    procedure AdvancedEditFrameSearchEdChange(Sender: TObject);
  private
    { Private declarations }
    MousePos: TPoint;

    BackupPNGImg: TPNGObject;

    BackupProfileDir: string;

    BackupThread: TBackupThread;
  public
    { Public declarations }
    CurrentCatalog: TMYX_CATALOG;
    CurrentSchema: TMYX_SCHEMA;

    //User must not expand SchemaTree manually
    LockSchemaTreeExpansion: Boolean;
  end;

  TBackupThread = class(TThread)
    constructor Create(AdminBackupForm: TAdminBackupForm;
      AdminBackupProgressForm: TAdminBackupProgressForm;
      filename: string);
    destructor Destroy; override;

    procedure UpdateProgressForm;
    procedure FinishedBackup;
    procedure FreeAdminBackupProgressForm;
    procedure ShowError;
    procedure CleanUp;
  protected
    procedure Execute; override;
  private
    PMySQL: Pointer;

    AdminBackupForm: TAdminBackupForm;
    filename: string;
  public
    AdminBackupProgressForm: TAdminBackupProgressForm;

    current_table_name: string;
    num_tables: integer;
    num_tables_processed: integer;
    num_rows: integer;
    num_rows_processed: integer;

    BackupError: MYX_BACKUP_ERROR;
  end;

  function BackupProgress(current_table_name: PChar;
    num_tables: Integer; num_tables_processed: Integer;
    num_rows: Integer; num_rows_processed: Integer;
    user_data: Pointer): integer; cdecl;

implementation

{$R *.dfm}

uses Main;

procedure TAdminBackupForm.FormCreate(Sender: TObject);
begin
  DockedPanel:=ServerBackupRestorePnl;
  SubTreePanel:=SubTreePnl;

  BackupRestorePageControl.ActivePageIndex:=0;

  CurrentCatalog:=nil;
  CurrentSchema:=nil;

  BackupThread:=nil;

  InitControls:=True;

  LockSchemaTreeExpansion:=True;

  SchemataFrame.InstanceDM:=InstanceDM;
  SchemataFrame.ShowSchemaAssets:=False;
  SchemataFrame.ShowTablesOnSchemaExpansion:=True;
  SchemataFrame.RefreshSchemaTree;

  BackupPNGImg:=LoadPNGImageFromResource('backup', BackupImg);
  Backup2Img.Picture.Assign(BackupPNGImg);
  Backup3Img.Picture.Assign(BackupPNGImg);

  if(MYXCommonOptions.XPStyleEnabled)then
  begin
    ContentSplitter.Color:=clWhite;
    ExecutionTimeGBox.Color:=clWhite;
    AdvOptionsScrollBox.Color:=clWhite;
  end;

  ClearControls(False);

  if(Not(InstanceDM.Connected))then
    NewProjectBtn.Enabled:=False;

  BackupProfileDir:=ExtractFilePath(Application.ExeName);

  RefreshBackupProfiles;
end;

procedure TAdminBackupForm.FormDestroy(Sender: TObject);
begin
  BackupPNGImg.Free;

  ClearListView(ProjectListView, myx_ndt_pointer);
end;

procedure TAdminBackupForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  //
end;


procedure TAdminBackupForm.RefreshSchemaTree(searchStr: String = '');
begin
  //
end;

procedure TAdminBackupForm.ServerBackupRestorePnlResize(
  Sender: TObject);
//var InitSheetWidth, InitSheetHeight: integer;
begin
  {InitSheetWidth:=563;
  InitSheetHeight:=451;

  //Adjust Page Control
  BackupRestorePageControl.Width:=ServerBackupRestorePnl.Width-591+571;
  BackupRestorePageControl.Height:=ServerBackupRestorePnl.Height-501+443;}

  //Backup Sheet
  BackupTreeViewHeaderControl.Left:=BackupTreeView.Left+1;
  BackupTreeViewHeaderControl.Width:=BackupTreeView.Width-2-18;
end;

procedure TAdminBackupForm.BackupTreeViewAdvancedCustomDrawItem(
  Sender: TCustomTreeView; Node: TTreeNode; State: TCustomDrawState;
  Stage: TCustomDrawStage; var PaintImages, DefaultDraw: Boolean);
var NodeRect: TRect;
  XPos: integer;
  theHeaderControl: THeaderControl;
  i: integer;
begin
  theHeaderControl:=BackupTreeViewHeaderControl;

  if(Stage=cdPrePaint)then
  begin
    Sender.Canvas.Pen.Style:=psSolid;
    if(cdsFocused in State)then
      Sender.Canvas.Pen.Color:=clGray
    else
      Sender.Canvas.Pen.Color:=clSilver;

    NodeRect:=Node.DisplayRect(False);

    if(cdsSelected in State)then
    begin
      Sender.Canvas.Brush.Color:=clWhite;
      Sender.Canvas.Pen.Color:=clGray;
      Sender.Canvas.Rectangle(NodeRect.Left+19+Node.Level*19+5-2, NodeRect.Top,
        Sender.Width-4-18, NodeRect.Bottom);
    end
    else
    begin
      Sender.Canvas.Brush.Color:=clWhite;
      Sender.Canvas.FillRect(Rect(NodeRect.Left+19+Node.Level*19+5-2, NodeRect.Top,
        Sender.Width-4-18, NodeRect.Bottom+1));
    end;

    Sender.Canvas.Brush.Color:=clWhite;

    DefaultDraw:=True;
  end
  else if(Stage=cdPostPaint)then
  begin
    if(Node.Data<>nil)then
    begin
      NodeRect:=Node.DisplayRect(False);

      if(cdsFocused in State)then
      begin
        Sender.Canvas.Pen.Color:=clGray;
        Sender.Canvas.Pen.Style:=psSolid;
        Sender.Canvas.Brush.Color:=clSilver;

        Sender.Canvas.Rectangle(NodeRect.Left+19+Node.Level*19+5-2, NodeRect.Top,
          Sender.Width-4-18, NodeRect.Bottom);

        Sender.Canvas.Brush.Style:=bsClear;

        Sender.Canvas.TextRect(Rect(
          NodeRect.Left+19+Node.Level*19+5, NodeRect.Top+1,
          theHeaderControl.Sections[0].Width+2, NodeRect.Top+16),
          NodeRect.Left+19+Node.Level*19+5, NodeRect.Top+1,
          Node.Text);
      end;

      ItemSelectImageList.Draw(Sender.Canvas,
        NodeRect.Left+19+Node.Level*19+5, NodeRect.Top+1,
        Ord(TBackupNode(Node.Data).GetSelectState));

      if(TBackupNode(Node.Data).GetObjType=BOTTable)and
        (TBackupNode(Node.Data).Substrings<>nil)then
      begin
        Sender.Canvas.Brush.Style:=bsClear;
        XPos:=0;
        for i:=0 to 3 do
        begin
          XPos:=XPos+theHeaderControl.Sections[i].Width;
          Sender.Canvas.TextRect(Rect(XPos+2, NodeRect.Top+1,
            XPos+theHeaderControl.Sections[i+1].Width-4, NodeRect.Top+16),
            XPos+2, NodeRect.Top+1,
            TBackupNode(Node.Data).Substrings[i]);
        end;
      end;
    end;
  end;
end;

procedure TAdminBackupForm.BackupTreeViewMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var Node: TTreeNode;
  NodeRect: TRect;
  Selected: TBackupCheckType;
begin
  Node:=TTreeView(Sender).GetNodeAt(x, y);
  if(Assigned(Node))then
  begin
    NodeRect:=Node.DisplayRect(False);

    if(X>NodeRect.Left+19+Node.Level*19+5)and(X<NodeRect.Left+19+Node.Level*19+5+14)and
      (Node.Data<>nil)then
    begin
      if(TBackupNode(Node.Data).GetSelectState<>BCTAll)then
        Selected:=BCTAll
      else
        Selected:=BCTNone;

      SetNodeSelectState(Node, Selected);

      DoChange(self);
    end;
  end;
end;

procedure TAdminBackupForm.BackupTreeViewHeaderControlSectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
begin
  BackupTreeView.Invalidate;
end;

procedure TAdminBackupForm.AddSchemaToBackup(Schema: TMYX_SCHEMA; Selected: Boolean);
var CatalogNode, SchemaNode: TTreeNode;
  i: integer;
  ptable_status: PMYX_SCHEMA_TABLE_STATUS;
  table_status: TMYX_SCHEMA_TABLE_STATUS;
  backup_node: TBackupNode;
begin
  CatalogNode:=nil;

  //Check if schema not already in Backup List
  for i:=0 to BackupTreeView.Items.Count-1 do
    if(BackupTreeView.Items[i].Data<>nil)then
      if(TObject(BackupTreeView.Items[i].Data) is TBackupNode)then
        if(TBackupNode(BackupTreeView.Items[i].Data).GetObjType=BOTSchema)then
          if(CompareText(TBackupNode(BackupTreeView.Items[i].Data).GetObjName,
            Schema.schema_name)=0)then
          begin
            //If Node has a parent, check catalog name, too
            if(BackupTreeView.Items[i].Parent<>nil)then
            begin
              if(BackupTreeView.Items[i].Parent.Data<>nil)then
                if(TObject(BackupTreeView.Items[i].Parent.Data) is TBackupNode)then
                  if(TBackupNode(BackupTreeView.Items[i].Parent.Data).GetObjType=BOTCatalog)then
                    if(CompareText(TBackupNode(BackupTreeView.Items[i].Parent.Data).GetObjName,
                      Schema.catalog_name)=0)then
                        Exit;
            end
            else
              Exit;
          end;

  if(BackupTreeView.Items.Count=0)then
    AddTreeViewChildNode(BackupTreeView, nil, 'BackupRoot', -1, nil);

  for i:=0 to BackupTreeView.Items.Count-1 do
    if(BackupTreeView.Items[i].Data<>nil)then
      if(TObject(BackupTreeView.Items[i].Data) is TBackupNode)then
        if(TBackupNode(BackupTreeView.Items[i].Data).GetObjType=BOTCatalog)then
          if(CompareText(TBackupNode(BackupTreeView.Items[i].Data).GetObjName,
            Schema.catalog_name)=0)then
          begin
            CatalogNode:=BackupTreeView.Items[i];
            break;
          end;


  if(CatalogNode=nil)then
  begin
    CatalogNode:=AddTreeViewChildNode(BackupTreeView, nil, //BackupTreeView.Items[0],
      '      '+Schema.catalog_name, 2,
      TBackupNode.Create(Schema.catalog_name, BOTCatalog));
  end;

  SchemaNode:=AddTreeViewChildNode(BackupTreeView, CatalogNode,
    '      '+Schema.schema_name, 9,
    TBackupNode.Create(Schema.schema_name, BOTSchema));

  //----------------------------------------------------------
  //Get Tables
  ptable_status:=myx_get_schema_table_status(InstanceDM.PMySQL, PChar(''),
    PChar(AnsiToUtf8(Schema.schema_name)));
  try
    table_status:=TMYX_SCHEMA_TABLE_STATUS.Create(ptable_status);

    for i:=0 to table_status.schema_tables.Count-1 do
    begin
      backup_node:=TBackupNode.Create(
        table_status.schema_tables[i].table_name, BOTTable);
      backup_node.Substrings:=TStringList.Create;
      backup_node.Substrings.Add(
        table_status.schema_tables[i].table_type);
      backup_node.Substrings.Add(
        table_status.schema_tables[i].rows);
      backup_node.Substrings.Add(
        table_status.schema_tables[i].data_length);
      backup_node.Substrings.Add(
        table_status.schema_tables[i].update_time);

      AddTreeViewChildNode(BackupTreeView, SchemaNode, '      '+
        table_status.schema_tables[i].table_name, 10,
        backup_node);
    end;

    //Select new Schema and all subnodes (tables)
    if(Selected)then
      SetNodeSelectState(SchemaNode, BCTAll);

    table_status.Free;
  finally
    myx_free_schema_table_status(ptable_status);
  end;

  //Expand nodes
  BackupTreeView.Items[0].Expand(False);
  CatalogNode.Expand(False);
end;

procedure TAdminBackupForm.BackupTreeViewDragOver(Sender,
  Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if(Source=SchemataFrame.SchemaTreeView)then
    Accept:=True;
end;

procedure TAdminBackupForm.BackupTreeViewDragDrop(Sender,
  Source: TObject; X, Y: Integer);
begin
  if(Source=SchemataFrame.SchemaTreeView)then
  begin
    AddSchemaToBackupBtnClick(self);
  end;
end;

procedure TAdminBackupForm.SchemaTreeViewExpanding(Sender: TObject;
  Node: TTreeNode; var AllowExpansion: Boolean);
begin
  //Expansion not allowed in Backup/Restore
  AllowExpansion:=Not(LockSchemaTreeExpansion);
end;

procedure TAdminBackupForm.BackupTreeViewPopupMenuPopup(
  Sender: TObject);
begin
  //Tables cannot be removed
  RemoveBackupNodeMI.Enabled:=True;
  if(BackupTreeView.Selected<>nil)then
    if(BackupTreeView.Selected.Data<>nil)then
      if(TBackupNode(BackupTreeView.Selected.Data).GetObjType=BOTTable)then
        RemoveBackupNodeMI.Enabled:=False;
end;

procedure TAdminBackupForm.RemoveBackupNodeMIClick(Sender: TObject);
begin
  if(BackupTreeView.Selected<>nil)then
    if(BackupTreeView.Selected.Data<>nil)then
    begin
      RemoveTreeNode(BackupTreeView.Selected);

      DoChange(self);

      StartBackupBtn.Enabled:=(GetSelectedTablesCount>0);
    end;
end;

procedure TAdminBackupForm.RemoveTreeNode(Node: TTreeNode);
begin
  //Remove Child nodes first
  while(Node.Count>0)do
    RemoveTreeNode(Node.Item[0]);

  TBackupNode(Node.Data).Free;

  TTreeView(Node.TreeView).Items.Delete(Node);
end;

procedure TAdminBackupForm.SchemaTreeViewCollapsing(Sender: TObject;
  Node: TTreeNode; var AllowCollapse: Boolean);
begin
  if(Node.Data<>nil)then
    if(TObject(Node.Data) is TMYX_CATALOG)then
      AllowCollapse:=False;
end;

procedure TAdminBackupForm.AddSchemaToBackupBtnClick(
  Sender: TObject);
var i, j: integer;
  {ListItem: TListItem;
  s: string;}
begin
  {if(ProjectListView.Selected=nil)then
  begin
    ListItem:=AddListViewItem(ProjectListView, nil,
      'New Project', -1, nil);
    ProjectListView.Selected:=ListItem;
    ListItem.SubItems.Add('');
    ListItem.SubItems.Add('15');
    ListItem.SubItems.Add('');
    ListItem.SubItems.Add(FormatDateTime('dd mmm yyyy', now));
  end;

  ListItem:=ProjectListView.Selected;
  if(ListItem<>nil)then
  begin
    if(ListItem.SubItems.Count>0)then
      s:=ListItem.SubItems[0]
    else
      s:='';

    if(s<>'')then
      s:=s+', ';

    for i:=0 to SchemataFrame.SchemaTreeView.SelectionCount-1 do
      if(SchemataFrame.SchemaTreeView.Selections[i].Data<>nil)then
        if(TObject(SchemataFrame.SchemaTreeView.Selections[i].Data) is TMYX_SCHEMA)then
          s:=s+SchemataFrame.SchemaTreeView.Selections[i].Text+', ';

    s:=Copy(s, 1, Length(s)-2);
    if(ListItem.SubItems.Count>0)then
      ListItem.SubItems[0]:=s;

  end;}

  for i:=0 to SchemataFrame.SchemaTreeView.SelectionCount-1 do
  begin
    if(SchemataFrame.SchemaTreeView.Selections[i].Data<>nil)then
    begin
      if(TObject(SchemataFrame.SchemaTreeView.Selections[i].Data) is TMYX_SCHEMA)then
        AddSchemaToBackup(TMYX_SCHEMA(SchemataFrame.SchemaTreeView.Selections[i].Data));

      if(TObject(SchemataFrame.SchemaTreeView.Selections[i].Data) is TMYX_CATALOG)then
        for j:=0 to TMYX_CATALOG(SchemataFrame.SchemaTreeView.Selections[i].Data).Schemata.Count-1 do
          AddSchemaToBackup(TMYX_CATALOG(SchemataFrame.SchemaTreeView.Selections[i].Data).Schemata[j]);
    end;
  end;

  DoChange(self);

  StartBackupBtn.Enabled:=(GetSelectedTablesCount>0);
end;

procedure TAdminBackupForm.SchemataFrameSchemaTreeViewMouseDown(
  Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  SchemataFrame.SchemaTreeViewMouseDown(Sender, Button, Shift, X, Y);

  if(Button=mbLeft)then
  begin
    MousePos:=Mouse.CursorPos;
  end;
end;

procedure TAdminBackupForm.SchemataFrameSchemaTreeViewMouseMove(
  Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if(ssLeft	in Shift)then
  begin
    //Simulate Treshold before Drag
    if((abs(MousePos.X-Mouse.CursorPos.X)>5)or
      (abs(MousePos.Y-Mouse.CursorPos.Y)>5))then
      SchemataFrame.SchemaTreeView.BeginDrag(True);
  end;
end;

procedure TAdminBackupForm.StartBackupBtnClick(Sender: TObject);
var
  SaveDialog: TSaveDialog;
  filename: string;
  AdminBackupProgressForm: TAdminBackupProgressForm;
begin
  SaveDialog:=TSaveDialog.Create(self);
  try
    SaveDialog.FileName:=FilenamePrefixEd.Text+
      FormatDateTime(' yyyymmdd hhnn', Now)+'.sql';
    SaveDialog.Filter:='SQL Backup Files|*.sql|All Files|*.*';

    if(Not(SaveDialog.Execute))then
      Exit;

    filename:=SaveDialog.Filename;
  finally
    SaveDialog.Free;
  end;

  AdminBackupProgressForm:=TAdminBackupProgressForm.Create(
    self, True,
    ProjectNameEd.Text);
  AdminBackupProgressForm.Show;

  BackupThread:=TBackupThread.Create(self, AdminBackupProgressForm,
    filename);
  try
    //Thread will be freed after execution
    BackupThread.FreeOnTerminate:=True;

    BackupThread.Resume;
  except
    BackupThread.Free;
  end;

  {backup_content:=GetBackupContent;
  try
    AdminBackupProgressForm:=TAdminBackupProgressForm.Create(self, True,
      ProjectNameEd.Text+'/'+ExtractFileName(filename));
    try
      AdminBackupProgressForm.Show;

      myx_make_backup(InstanceDM.PMySQL, PChar(filename),
        backup_content.get_record_pointer, MYX_BT_SQL_SCRIPT,
        GetOptions, 1024, BackupProgress, Addr(AdminBackupProgressForm));

      ShowModalDialog('Backup finished',
        'The Backup was finished successfully.'#13#10#13#10+
        'The File '+filename+' has been created.',
        myx_mtConfirmation, 'OK');
    finally
      AdminBackupProgressForm.Free;
      AdminBackupProgressForm:=nil;
    end;
  finally
    backup_content.Free;
  end;}
end;

procedure TAdminBackupForm.BackupTreeViewChanging(Sender: TObject;
  Node: TTreeNode; var AllowChange: Boolean);
begin
  if(BackupTreeView.Items.Count>0)then
    if(Node=BackupTreeView.Items[0])then
      AllowChange:=False;
end;

procedure TAdminBackupForm.ClearControls(EnableControls: Boolean);
begin
  InitControls:=True;

  DisableEnableControls(BackupContentTabSheet, EnableControls);
  DisableEnableControls(AdvancedOptionsTabSheet, EnableControls);
  DisableEnableControls(ScheduleTabSheet, False);

  ApplyBtn.Enabled:=False;
  //DiscardBtn.Enabled:=False;
  StartBackupBtn.Enabled:=False;

  ProjectNameEd.Text:='';
  TargetDirEd.Text:='';
  FilenamePrefixEd.Text:='';

  NoCreatesCBox.Checked:=False;
  NoExtendedInsertsCBox.Checked:=False;
  AddDropTableCBox.Checked:=False;
  CompleteInsertsCBox.Checked:=True;
  CommentCBox.Checked:=False;
  FullPathCBox.Checked:=False;
  AnsiQuotesCBox.Checked:=False;
  LockAllTablesRButton.Checked:=True;
  DisableKeysCBox.Checked:=False;
  CompleteSchematasCBox.Checked:=False;

  BackupFileTypesLU.ItemIndex:=0;

  ClearTreeView(BackupTreeView, myx_ndt_tobject);

  InitControls:=False;
end;


procedure TAdminBackupForm.NewProjectBtnClick(Sender: TObject);
begin
  DiscardChanges(True);

  BackupRestorePageControl.ActivePageIndex:=0;

  ProjectListView.Selected:=nil;
  ClearControls(True);

  ProjectNameEd.Text:='New Project';
  ProjectNameEd.SetFocus;
  ProjectNameEd.SelectAll;
end;

procedure TAdminBackupForm.ProjectNameEdExit(Sender: TObject);
begin
  if(FilenamePrefixEd.Text='')then
    FilenamePrefixEd.Text:=ProjectNameEd.Text;
end;

procedure TAdminBackupForm.BrowseTargetDirBtnClick(Sender: TObject);
var SaveDialog: TSaveDialog;
begin
  SaveDialog:=TSaveDialog.Create(self);
  SaveDialog.Title:='Choose Target Directory';
  SaveDialog.InitialDir:='';
  SaveDialog.FileName:='Browse to the Target Directory';

  if(SaveDialog.Execute)then
  begin
    TargetDirEd.Text:=ExtractFilePath(SaveDialog.FileName);
  end;
end;

procedure TAdminBackupForm.DoChange(Sender: TObject);
begin
  if(Not(InitControls))then
  begin
    ApplyBtn.Enabled:=True;
    //DiscardBtn.Enabled:=True;
  end;
end;

procedure TAdminBackupForm.DiscardChanges(AskBeforeDiscard: Boolean);
var res: integer;
begin
  if(Not(ApplyBtn.Enabled))then
    Exit;

  if(AskBeforeDiscard)then
  begin
    res:=ShowModalDialog('Apply changes?',
      'The current backup profile has been changed. '+
      'Do you want to apply your changes?',
      myx_mtConfirmation, 'Yes'#13#10'No'#13#10'Abort');
    if(res=1)then
    begin
      ApplyChanges;
      Exit;
    end
    else if(res=3)then
      Abort;
  end;

  if(ProjectListView.Selected=nil)then
    ClearControls(False)
  else
  begin
    ApplyBtn.Enabled:=False;
    //DiscardBtn.Enabled:=False;

    //Reload profile
    LoadProfile(PChar(ProjectListView.Selected.Data));
  end;
end;

function TAdminBackupForm.GetOptions: integer;
var options: integer;
begin
  options:=0;

  AddOption(options, MYX_B_NO_CREATES, NoCreatesCBox.Checked);
  AddOption(options, MYX_B_NO_EXTENDED_INSERT, NoExtendedInsertsCBox.Checked);
  AddOption(options, MYX_B_ADD_DROP_TABLE, AddDropTableCBox.Checked);
  AddOption(options, MYX_B_COMPLETE_INSERTS, CompleteInsertsCBox.Checked);
  AddOption(options, MYX_B_COMMENT, CommentCBox.Checked);
  AddOption(options, MYX_B_DONT_WRITE_FULL_PATH, FullPathCBox.Checked);
  AddOption(options, MYX_B_ANSI_QUOTES, AnsiQuotesCBox.Checked);
  AddOption(options, MYX_B_LOCK_ALL_TABLES, LockAllTablesRButton.Checked);
  AddOption(options, MYX_B_SINGLE_TRANSACTION, SingleTransRButton.Checked);
  AddOption(options, MYX_B_DISABLE_KEYS, DisableKeysCBox.Checked);
  AddOption(options, MYX_B_COMPLETE_SCHEMATAS, CompleteSchematasCBox.Checked);

  Result:=options;
end;

procedure TAdminBackupForm.ApplyChanges;
var Profile: TMYX_BACKUP_PROFILE;
  Content: TMYX_BACKUP_CONTENT;
  BackupType: MYX_BACKUP_TYPE;
  filename: string;
begin
  //Get Backup FileType
  case BackupFileTypesLU.ItemIndex of
    0:
      BackupType:=MYX_BT_SQL_SCRIPT;
  else
    BackupType:=MYX_BT_SQL_SCRIPT;
  end;

  Content:=GetBackupContent(BackupTreeView);
  try
    Profile:=TMYX_BACKUP_PROFILE.create(ProjectNameEd.Text,
      TargetDirEd.Text,
      FilenamePrefixEd.Text,
      '',
      GetOptions,
      BackupType,
      Content.get_record_pointer);
    try
      filename:=ExtractFilePath(Application.ExeName)+ExtractText(ProjectNameEd.Text)+'.mbp';
      if(FileExists(filename))then
      begin
        DeleteFile(ChangeFileExt(filename, '.bak'));
        RenameFile(filename,
          ChangeFileExt(filename, '.bak'));
      end;

      myx_save_profile(PChar(AnsiToUtf8(ExtractText(ProjectNameEd.Text)+'.mbp')),
        PChar(AnsiToUtf8(ExtractFilePath(Application.ExeName))),
        Profile.get_record_pointer);
    finally
      Profile.Free;
    end;

  finally
    Content.Free;
  end;

  ApplyBtn.Enabled:=False;
  //DiscardBtn.Enabled:=False;

  if(ProjectListView.Selected=nil)then
    RefreshBackupProfiles(filename);
end;

procedure TAdminBackupForm.DiscardBtnClick(Sender: TObject);
begin
  DiscardChanges(False);
end;

procedure TAdminBackupForm.ApplyBtnClick(Sender: TObject);
begin
  ApplyChanges;
end;

function StrMatchesSearchStr(Str: String; searchStr: String): Boolean;
begin
  StrMatchesSearchStr:=True;

  if(searchStr<>'')then
    StrMatchesSearchStr:=(myx_match_string(PChar(AnsiToUtf8(Str)),
      PChar(AnsiToUtf8(searchStr)), 0)<>0);
end;

procedure TAdminBackupForm.RefreshBackupProfiles(SelectProfile: string);
var CurrentProfileName: string;
  SR: TSearchRec;
  filename: PChar;
  i: integer;
begin
  CurrentProfileName:=SelectProfile;
  if(ProjectListView.Selected<>nil)then
    if(ProjectListView.Selected.Data<>nil)then
      CurrentProfileName:=PChar(ProjectListView.Selected.Data);


  InitControls:=True;
  ProjectListView.Items.BeginUpdate;
  try
    ClearListView(ProjectListView, myx_ndt_pointer);

    if(FindFirst(BackupProfileDir+'*.mbp', faAnyFile and not
      (8 {faVolumeID} or faDirectory), sr)=0)then
    begin
      repeat
      begin
        if(AdvancedEditFrame.SearchEd.Text<>'')then
          if(Not(StrMatchesSearchStr(sr.Name, AdvancedEditFrame.SearchEd.Text)))then
            continue;

        GetMem(filename, Length(BackupProfileDir+sr.Name)+1);
        StrPCopy(filename, BackupProfileDir+sr.Name);

        AddListViewItem(ProjectListView, nil,
          ExtractFileName(Copy(sr.Name, 1, Length(sr.Name)-Length(ExtractFileExt(sr.Name)))),
          -1, filename);
      end;
      until FindNext(sr) <> 0;

      FindClose(sr);
    end;

    for i:=0 to ProjectListView.Items.Count-1 do
      if(ProjectListView.Items[i].Data<>nil)then
        if(CompareText(CurrentProfileName,
          PChar(ProjectListView.Items[i].Data))=0)then
        begin
          ProjectListView.Selected:=ProjectListView.Items[i];
          break;
        end;
  finally
    ProjectListView.Items.EndUpdate;
    InitControls:=False;
  end;
end;

function TAdminBackupForm.InOptions(options: integer;
  option: MYX_BACKUP_OPTIONS): Boolean;
begin
  Result:=((options and ord(option))=Ord(option));
end;

procedure TAdminBackupForm.AddOption(var options: integer;
  option: MYX_BACKUP_OPTIONS; Add: Boolean);
begin
  if(Add)then
    options:=(options + ord(option));
end;

procedure TAdminBackupForm.LoadProfile(filename: string);
var Profile: TMYX_BACKUP_PROFILE;
  PProfile: PMYX_BACKUP_PROFILE;
  error: MYX_ADMIN_LIB_ERROR;
begin
  if(Not(InstanceDM.Connected))then
    Exit;

  PProfile:=myx_load_profile(PChar(AnsiToUtf8(ExtractFileName(filename))),
    PChar(AnsiToUtf8(ExtractFilePath(filename))), @error);
  if(error<>MYX_ADMIN_NO_ERROR)or(PProfile=nil)then
    raise EMyxAdminLibError.Create(Ord(error), filename);

  InitControls:=True;
  try
    Profile:=TMYX_BACKUP_PROFILE.create(PProfile);
  finally
    myx_free_profile(PProfile);
  end;

  try
    ProjectNameEd.Text:=Profile.profile_name;
    TargetDirEd.Text:=Profile.target_directory;
    FilenamePrefixEd.Text:=Profile.filename_prefix;

    BackupFileTypesLU.ItemIndex:=Ord(Profile.backup_type);

    NoCreatesCBox.Checked:=InOptions(Profile.options, MYX_B_NO_CREATES);
    NoExtendedInsertsCBox.Checked:=InOptions(Profile.options, MYX_B_NO_EXTENDED_INSERT);
    AddDropTableCBox.Checked:=InOptions(Profile.options, MYX_B_ADD_DROP_TABLE);
    CompleteInsertsCBox.Checked:=InOptions(Profile.options, MYX_B_COMPLETE_INSERTS);
    CommentCBox.Checked:=InOptions(Profile.options, MYX_B_COMMENT);
    FullPathCBox.Checked:=InOptions(Profile.options, MYX_B_DONT_WRITE_FULL_PATH);
    AnsiQuotesCBox.Checked:=InOptions(Profile.options, MYX_B_ANSI_QUOTES);
    LockAllTablesRButton.Checked:=InOptions(Profile.options, MYX_B_LOCK_ALL_TABLES);
    SingleTransRButton.Checked:=InOptions(Profile.options, MYX_B_SINGLE_TRANSACTION);
    DisableKeysCBox.Checked:=InOptions(Profile.options, MYX_B_DISABLE_KEYS);
    CompleteSchematasCBox.Checked:=InOptions(Profile.options, MYX_B_COMPLETE_SCHEMATAS);

    BuildContentTreeFromBackupContent(InstanceDM.PMySQL,
      BackupTreeView,
      Profile.backup_content,
      SchemataFrame,
      CompleteSchematasCBox.Checked);
  finally
    InitControls:=False;
    Profile.Free;
  end;

  StartBackupBtn.Enabled:=(GetSelectedTablesCount>0);
end;

function TAdminBackupForm.GetSelectedTablesCount: integer;
var i, count: integer;
begin
  count:=0;

  for i:=0 to BackupTreeView.Items.Count-1 do
    if(BackupTreeView.Items[i].Data<>nil)then
      if(TObject(BackupTreeView.Items[i].Data) is TBackupNode)then
        if(TBackupNode(BackupTreeView.Items[i].Data).GetObjType=BOTTable)and
          (TBackupNode(BackupTreeView.Items[i].Data).GetSelectState=BCTAll)then
          inc(count);

  Result:=count;
end;

procedure TAdminBackupForm.RefreshProfilesMIClick(Sender: TObject);
begin
  RefreshBackupProfiles;
end;

procedure TAdminBackupForm.ProjectListViewEdited(Sender: TObject;
  Item: TListItem; var S: String);
var PFilename: PChar;
begin
  if(Item.Data<>nil)then
  begin
    If(RenameFile(PChar(Item.Data),
      ExtractFilePath(PChar(Item.Data))+ExtractText(S)+'.mbp'))then
    begin
      S:=ExtractText(S);

      FreeMem(Item.Data);

      GetMem(PFilename, Length(ExtractFilePath(PChar(Item.Data))+ExtractText(S)+'.mbp')+1);
      StrPCopy(PFilename, ExtractFilePath(PChar(Item.Data))+ExtractText(S)+'.mbp');

      Item.Data:=PFilename;
    end;
  end;
end;

procedure TAdminBackupForm.DeleteProfileMIClick(Sender: TObject);
var i: integer;
begin
  if(ShowModalDialog('Delete Profiles?',
    'Are you sure you want to delete the selected profiles?',
    myx_mtConfirmation, 'Yes'#13#10'No')=1)then
  begin
    InitControls:=True;
    try
      for i:=0 to ProjectListView.Items.Count-1 do
        if(ProjectListView.Items[i].Selected)then
          if(ProjectListView.Items[i].Data<>nil)then
            DeleteFile(PChar(ProjectListView.Items[i].Data));

      RefreshBackupProfiles;

      ProjectListView.Selected:=nil;
      ClearControls(True);
    finally
      InitControls:=False;
    end;
  end;

end;

procedure TAdminBackupForm.ProfilesPopupMenuPopup(Sender: TObject);
begin
  DeleteProfileMI.Enabled:=ProjectListView.SelCount>0;
end;

procedure TAdminBackupForm.ClearCompleteContentMIClick(
  Sender: TObject);
begin
  ClearTreeView(BackupTreeView, myx_ndt_tobject);

  DoChange(self);

  StartBackupBtn.Enabled:=(GetSelectedTablesCount>0);
end;

procedure TAdminBackupForm.ProjectListViewSelectItem(
  Sender: TObject; Item: TListItem; Selected: Boolean);
begin
  if(Not(InitControls))then
  begin
    if(ProjectListView.Selected<>nil)and
      (InstanceDM.Connected)then
    begin
      if(ProjectListView.Selected.Data<>nil)then
      begin
        if(ApplyBtn.Enabled)then
          DiscardChanges(True);

        LoadProfile(PChar(ProjectListView.Selected.Data));

        DisableEnableControls(BackupContentTabSheet, True);
        DisableEnableControls(AdvancedOptionsTabSheet, True);
        DisableEnableControls(ScheduleTabSheet, False);

        Exit;
      end;
    end
    else
      ClearControls(False);
  end;
end;

constructor TBackupThread.Create(
  AdminBackupForm: TAdminBackupForm;
  AdminBackupProgressForm: TAdminBackupProgressForm;
  filename: string);
begin
  inherited Create(True);

  self.AdminBackupForm:=AdminBackupForm;
  self.AdminBackupProgressForm:=AdminBackupProgressForm;
  self.filename:=filename;

  PMySQL:=myx_mysql_init();
  if(PMySQL=nil)then
    raise EMyxError.Create('Error while allocating memory for MySQL Struct in Backup Thread.');

  
  if(myx_connect_to_instance(
    AdminBackupForm.InstanceDM.User_Connection.get_record_pointer,
    PMySQL)<>0)then
    raise EMyxError.Create('Backup Thread cannot connect to MySQL');
end;

destructor TBackupThread.Destroy;
begin
  CleanUp;

  inherited Destroy;
end;

procedure TBackupThread.CleanUp;
begin
  myx_mysql_close(PMySQL);

  AdminBackupForm.BackupThread:=nil;

  Synchronize(FreeAdminBackupProgressForm);
end;

function BackupProgress(current_table_name: PChar;
  num_tables: Integer; num_tables_processed: Integer;
  num_rows: Integer; num_rows_processed: Integer; user_data: Pointer): integer;
var PSender: ^TBackupThread;
begin
  PSender:=user_data;

  with PSender.AdminBackupProgressForm do
  begin
    PSender.current_table_name:=current_table_name;
    PSender.num_tables:=num_tables;
    PSender.num_tables_processed:=num_tables_processed;
    PSender.num_rows:=num_rows;
    PSender.num_rows_processed:=num_rows_processed;
  end;

  PSender.Synchronize(PSender.UpdateProgressForm);

  Result:=Ord(PSender.AdminBackupProgressForm.Stopping);
end;

procedure TBackupThread.Execute;
var backup_content: TMYX_BACKUP_CONTENT;
begin
  with AdminBackupForm do
  begin
    backup_content:=GetBackupContent(BackupTreeView);
    try
      BackupError:=myx_make_backup(PMySQL, PChar(AnsiToUtf8(filename)),
        backup_content.get_record_pointer, MYX_BT_SQL_SCRIPT,
        GetOptions, 256, BackupProgress, Addr(self));

      if(BackupError=MYX_BACKUP_NO_ERROR)then
        Synchronize(FinishedBackup)
      else
        Synchronize(ShowError);

    finally
      backup_content.Free;
    end;
  end;
end;

procedure TBackupThread.UpdateProgressForm;
begin
  with AdminBackupProgressForm do
  begin
    CurrentTableNameLbl.Caption:=
      current_table_name;

    TablesLbl.Caption:=IntToStr(num_tables);
    CurrentTableLbl.Caption:=IntToStr(num_tables_processed);
    TablesProgressBar.Max:=num_tables;
    TablesProgressBar.Position:=num_tables_processed-1;

    TotalRowsLbl.Caption:=IntToStr(num_rows);
    CurrentRowLbl.Caption:=IntToStr(num_rows_processed);
    RowProgressBar.Max:=num_rows;
    RowProgressBar.Position:=num_rows_processed-1;

    Refresh;
  end;
end;

procedure TBackupThread.FinishedBackup;
begin
  //Set Progress Bars to 100%
  num_tables_processed:=num_tables+1;
  num_rows_processed:=num_rows+1;

  UpdateProgressForm;

  ShowModalDialog('Backup finished',
    'The Backup was finished successfully.'#13#10#13#10+
    'The File '+filename+' has been created.',
    myx_mtConfirmation, 'OK');
end;

procedure TBackupThread.FreeAdminBackupProgressForm;
begin
  if(AdminBackupProgressForm<>nil)then
    AdminBackupProgressForm.Free;
end;

procedure TBackupThread.ShowError;
var ErrorTxt: string;
begin
  if(ord(BackupError)=-1)then
  begin
    ShowModalDialog('Backup stopped',
      'The Backup has been stopped.',
      myx_mtConfirmation, 'OK');
  end
  else
  begin
    ErrorTxt:=GetBackupErrorMsg(BackupError);
    case BackupError of
      MYX_BACKUP_MYSQL_ERROR:
        ErrorTxt:=Format(ErrorTxt, [myx_mysql_errno(AdminBackupForm.InstanceDM.PMySQL),
          myx_mysql_error(AdminBackupForm.InstanceDM.PMySQL)]);
      MYX_BACKUP_CANT_OPEN_FILE:
        ErrorTxt:=Format(ErrorTxt, [filename]);
    end;

    ShowModalDialog('Backup error',
      'An Error occured while executing the backup.'#13#10#13#10+
      ErrorTxt,
      myx_mtConfirmation, 'OK');
  end;
end;

procedure TAdminBackupForm.Disconnected(var Message: TMessage);
begin
  ClearControls(False);

  NewProjectBtn.Enabled:=False;

  ProjectListView.Selected:=nil;
end;

procedure TAdminBackupForm.Reconnected(var Message: TMessage);
begin
  NewProjectBtn.Enabled:=True;

  SchemataFrame.RefreshSchemaTree;

  ProjectListView.Selected:=nil;
end;

procedure TAdminBackupForm.AdvancedEditFrameSearchEdChange(
  Sender: TObject);
begin
  AdvancedEditFrame.SearchEdChange(Sender);

  RefreshBackupProfiles;
end;

end.
