unit AdminCatalog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, InstanceSections, Buttons,
  Contnrs, Menus, AuxFuncs, myx_public_interface, AdvancedEdit,
  SchemataTreeView, InstanceDataModule, AdditionalClasses,
  AdminCatalogTableCheck, Options, MyxError;

type
  TAdminCatalogForm = class(TInstanceSectionForm)
    SubTreePnl: TPanel;
    Splitter1: TSplitter;
    CatalogPnl: TPanel;
    CatalogPageControl: TPageControl;
    CatalogSheet: TTabSheet;
    SchemaSheet: TTabSheet;
    TopPnl: TPanel;
    SchemaPageControl: TPageControl;
    TablesTabSheet: TTabSheet;
    IndicesTabSheet: TTabSheet;
    StoredProcTabSheet: TTabSheet;
    DevDocTabSheet: TTabSheet;
    UsersTabSheet: TTabSheet;
    Panel3: TPanel;
    Panel5: TPanel;
    TablesTitleLbl: TLabel;
    Header1Img: TImage;
    Panel1: TPanel;
    IndicesBevel: TBevel;
    IndicesTitleLbl: TLabel;
    Image1: TImage;
    Panel2: TPanel;
    StoredProcBevel: TBevel;
    StoredProcTitleLbl: TLabel;
    Image2: TImage;
    Panel4: TPanel;
    DevDocBevel: TBevel;
    DevObjTitleLbl: TLabel;
    Image4: TImage;
    Panel6: TPanel;
    UsersBevel: TBevel;
    UsersTitleLbl: TLabel;
    Image5: TImage;
    TablesListView: TListView;
    Panel7: TPanel;
    Panel8: TPanel;
    RefreshIndicesBtn: TButton;
    StoredProcListView: TListView;
    Panel10: TPanel;
    Panel11: TPanel;
    Button3: TButton;
    Button5: TButton;
    Button6: TButton;
    Button9: TButton;
    DevDocTreeView: TTreeView;
    DevDocTreeViewHeaderControl: THeaderControl;
    Panel12: TPanel;
    Panel13: TPanel;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    UsersListView: TListView;
    IndexTreeView: TTreeView;
    TablesOptionsPageControl: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TableIndexTreeView: TTreeView;
    TableIndexTreeViewHeaderControl: THeaderControl;
    GroupBox2: TGroupBox;
    Label27: TLabel;
    RowFormatLbl: TLabel;
    TableTypeLbl: TLabel;
    Label24: TLabel;
    TableCommentGBox: TGroupBox;
    TableCommentLbl: TLabel;
    Label40: TLabel;
    AutoIncLbl: TLabel;
    Label48: TLabel;
    CreateOptionsLbl: TLabel;
    ViewsTabSheet: TTabSheet;
    Panel14: TPanel;
    ViewsBevel: TBevel;
    ViewsTitleLbl: TLabel;
    Image6: TImage;
    ViewsListView: TListView;
    Panel15: TPanel;
    Panel16: TPanel;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    SelectSchemaLbl: TLabel;
    TabSheet3: TTabSheet;
    GroupBox3: TGroupBox;
    Label28: TLabel;
    RowsLbl: TLabel;
    AvgRowLengthLbl: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    DataLengthLbl: TLabel;
    Label34: TLabel;
    MaxDataLenLbl: TLabel;
    Label36: TLabel;
    IndexLenLbl: TLabel;
    Label38: TLabel;
    DataFreeLbl: TLabel;
    TableTimeGBox: TGroupBox;
    Label2: TLabel;
    TblCreateTimeLbl: TLabel;
    Label4: TLabel;
    TblUpdateTimeLbl: TLabel;
    Label6: TLabel;
    TblCheckTimeLbl: TLabel;
    EventsTabSheet: TTabSheet;
    Panel17: TPanel;
    EventsBevel: TBevel;
    EventsTitleLbl: TLabel;
    Image7: TImage;
    TablesSchemaLbl: TLabel;
    IndicesSchemaLbl: TLabel;
    SchemataFrame: TSchemataFrame;
    ListView1: TListView;
    ColumnsTabSheet: TTabSheet;
    ColumnListView: TListView;
    ThreadsBevel: TBevel;
    TableInfoSplitter: TSplitter;
    OptimizeTablesBtn: TButton;
    CheckTablesBtn: TButton;
    RefreshBtn: TButton;
    TablenamePnl: TPanel;
    TableNameLbl: TLabel;
    Label1: TLabel;
    Label9: TLabel;
    IndexTreeViewHeaderControl: THeaderControl;
    RepairTablesBtn: TButton;
    Button1: TButton;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CatalogPnlResize(Sender: TObject);

    procedure SchemaPageControlChange(Sender: TObject);
    procedure DevDocTreeViewAdvancedCustomDrawItem(Sender: TCustomTreeView;
      Node: TTreeNode; State: TCustomDrawState; Stage: TCustomDrawStage;
      var PaintImages, DefaultDraw: Boolean);
    procedure DevDocTreeViewHeaderControlSectionResize(
      HeaderControl: THeaderControl; Section: THeaderSection);
    procedure TableIndexTreeViewHeaderControlSectionResize(
      HeaderControl: THeaderControl; Section: THeaderSection);

    procedure BuildSchemaPages(Schema: TMYX_SCHEMA = nil);
    procedure SchemataTreeAdvEditSeachEdChange(Sender: TObject);
    procedure SchemataFrameSchemaTreeViewChange(Sender: TObject;
      Node: TTreeNode);
    procedure TablesListViewChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure TableIndexTreeViewChanging(Sender: TObject; Node: TTreeNode;
      var AllowChange: Boolean);
    procedure TablesOptionsPageControlChange(Sender: TObject);

    procedure IndexTreeViewHeaderControlSectionResize(
      HeaderControl: THeaderControl; Section: THeaderSection);

    procedure FetchSchemaTableStatus(Sender: TObject);
    procedure FetchedSchemaTableStatus(Sender: TObject);
    procedure SchemataFrameSchemaTreeViewChanging(Sender: TObject;
      Node: TTreeNode; var AllowChange: Boolean);
    procedure ClearTableInfos;
    procedure ClearControls;

    procedure Disconnected(var Message: TMessage); message WM_Disconnected;
    procedure Reconnected(var Message: TMessage); message WM_Reconnected;
    procedure CheckTablesBtnClick(Sender: TObject);
    procedure TablesListViewKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SchemataFrameRefreshCatalogsSchemataListMIClick(
      Sender: TObject);
    procedure RefreshBtnClick(Sender: TObject);
  private
    { Private declarations }
    CurrentSchema: TMYX_SCHEMA;
    CurrentTableList: TMYX_SCHEMA_TABLE_STATUS;
  public
    { Public declarations }
    AdminCatalogTableCheckForm: TAdminCatalogTableCheckForm;
  end;

var
  AdminCatalogForm: TAdminCatalogForm;

implementation

uses Main, ApplicationDataModule;

{$R *.dfm}

procedure TAdminCatalogForm.FormCreate(Sender: TObject);
begin
  SchemataFrame.InstanceDM:=InstanceDM;

  DockedPanel:=CatalogPnl;
  SubTreePanel:=SubTreePnl;

  //Init PageControls
  CatalogPageControl.ActivePageIndex:=0;
  SchemaPageControl.ActivePageIndex:=0;
  TablesOptionsPageControl.ActivePageIndex:=0;

  //Hide CatalogPageControl Buttons
  TopPnl.Height:=9;

  CurrentSchema:=nil;
  CurrentTableList:=nil;

  AdminCatalogTableCheckForm:=nil;

  //For MySQL Versions < 5 hide Views, StoredProcedures and Events
  ViewsTabSheet.TabVisible:=False;
  StoredProcTabSheet.TabVisible:=False;
  EventsTabSheet.TabVisible:=False;
  DevDocTabSheet.TabVisible:=False;

  SchemataFrame.RefreshSchemaTree;

  if(MYXCommonOptions.XPStyleEnabled)then
    TableInfoSplitter.Color:=clWhite;


  //Disable Users for now
  DisableEnableControls(UsersTabSheet, False);
end;

procedure TAdminCatalogForm.FormDestroy(Sender: TObject);
begin
  //
end;

procedure TAdminCatalogForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  //AdminCatalogTableCheckForm.Close;

  Action:=caFree;
end;

procedure TAdminCatalogForm.CatalogPnlResize(Sender: TObject);
var InitSheetWidth, InitSheetHeight: integer;
begin
  //Position Catalog PageControl
  CatalogPageControl.Top:=0;
  CatalogPageControl.Left:=0;
  CatalogPageControl.Width:=CatalogPnl.Width;
  CatalogPageControl.Height:=CatalogPnl.Height;

  SelectSchemaLbl.Width:=CatalogPnl.Width-591+555;
  SelectSchemaLbl.Top:=CatalogPnl.Height div 2-18;

  //Size Schema PageControl
  SchemaPageControl.Width:=SchemaSheet.Width-583+569;
  SchemaPageControl.Height:=SchemaSheet.Height-487+479;

  InitSheetWidth:=561; //of SchemaPageControl
  InitSheetHeight:=451;

  //Table TabSheet
  TableIndexTreeViewHeaderControl.Width:=TableIndexTreeView.Width-4-17;

  TableCommentGBox.Width:=IndicesTabSheet.Width-InitSheetWidth+243;
  TableTimeGBox.Width:=IndicesTabSheet.Width-InitSheetWidth+243;

  //Indices TabSheet
  IndicesBevel.Width:=IndicesTabSheet.Width-InitSheetWidth+535;

  IndexTreeViewHeaderControl.Width:=IndicesTabSheet.Width-InitSheetWidth+516;

  IndexTreeView.Width:=IndicesTabSheet.Width-InitSheetWidth+535;
  IndexTreeView.Height:=IndicesTabSheet.Height-InitSheetHeight+349;

  //Views TabSheet
  ViewsBevel.Width:=IndicesTabSheet.Width-InitSheetWidth+535;

  ViewsListView.Width:=IndicesTabSheet.Width-InitSheetWidth+535;
  ViewsListView.Height:=IndicesTabSheet.Height-InitSheetHeight+349;

  //StoredProc TabSheet
  StoredProcBevel.Width:=StoredProcTabSheet.Width-InitSheetWidth+535;

  StoredProcListView.Width:=StoredProcTabSheet.Width-InitSheetWidth+535;
  StoredProcListView.Height:=StoredProcTabSheet.Height-InitSheetHeight+349;

  //Events TabSheet
  EventsBevel.Width:=StoredProcTabSheet.Width-InitSheetWidth+535;

  //DevDoc TabSheet
  DevDocBevel.Width:=DevDocTabSheet.Width-InitSheetWidth+535;

  DevDocTreeView.Width:=DevDocTabSheet.Width-InitSheetWidth+535;
  DevDocTreeView.Height:=DevDocTabSheet.Height-InitSheetHeight+349;

  DevDocTreeViewHeaderControl.Width:=DevDocTabSheet.Width-InitSheetWidth+516;

  //Users TabSheet
  UsersBevel.Width:=UsersTabSheet.Width-InitSheetWidth+535;

  {UsersListView.Width:=UsersTabSheet.Width-InitSheetWidth+535;
  UsersListView.Height:=UsersTabSheet.Height-InitSheetHeight+349;}
end;

procedure TAdminCatalogForm.SchemaPageControlChange(Sender: TObject);
begin
  CatalogPnlResize(self);

  //Select Node in Schema tree, also
  //For MySQL Versions < 5 hide Views, StoredProcedures and Events
  {if(InstanceDM.MySQLMajorVersion<5)and(SchemaPageControl.ActivePageIndex>1)then
    SchemaTreeView.Selected:=CurrentSchemaNodes[SchemaPageControl.ActivePageIndex+1-3]
  else
    SchemaTreeView.Selected:=CurrentSchemaNodes[SchemaPageControl.ActivePageIndex+1];}
end;

procedure TAdminCatalogForm.DevDocTreeViewAdvancedCustomDrawItem(
  Sender: TCustomTreeView; Node: TTreeNode; State: TCustomDrawState;
  Stage: TCustomDrawStage; var PaintImages, DefaultDraw: Boolean);
var NodeRect: TRect;
  XPos: integer;
  theHeaderControl: THeaderControl;
  i: integer;
begin
  if(TTreeView(Sender).Name='IndexTreeView')then
    theHeaderControl:=IndexTreeViewHeaderControl
  else if(TTreeView(Sender).Name='TableIndexTreeView')then
    theHeaderControl:=TableIndexTreeViewHeaderControl
  else
    theHeaderControl:=DevDocTreeViewHeaderControl;

  if(Stage=cdPrePaint)then
  begin
    Sender.Canvas.Pen.Style:=psSolid;
    if(cdsFocused in State)then
      Sender.Canvas.Pen.Color:=clGray
    else
      Sender.Canvas.Pen.Color:=clSilver;

    NodeRect:=Node.DisplayRect(False);

    if(cdsSelected in State)then
    begin
      Sender.Canvas.Brush.Color:=clSilver;
      Sender.Canvas.Pen.Color:=clGray;
      Sender.Canvas.Rectangle(NodeRect.Left{+19}+Node.Level*19+5-2, NodeRect.Top,
        Sender.Width-4-18, NodeRect.Bottom);
    end
    else
    begin
      Sender.Canvas.Brush.Color:=clWhite;
      Sender.Canvas.FillRect(Rect(NodeRect.Left{+19}+Node.Level*19+5-2, NodeRect.Top,
        Sender.Width-4-18, NodeRect.Bottom+1));
    end;

    Sender.Canvas.Brush.Color:=clWhite;

    DefaultDraw:=True;
  end
  else if(Stage=cdPostPaint)then
  begin
    if(Node.Data<>nil)then
    begin
      NodeRect:=Node.DisplayRect(False);

      if(cdsFocused in State)then
      begin
        Sender.Canvas.Pen.Color:=clGray;
        Sender.Canvas.Pen.Style:=psSolid;
        Sender.Canvas.Brush.Color:=clSilver;

        Sender.Canvas.Rectangle(NodeRect.Left+19+Node.Level*19+5-2, NodeRect.Top,
          Sender.Width-4-18, NodeRect.Bottom);

        Sender.Canvas.Brush.Style:=bsClear;

        Sender.Canvas.TextRect(Rect(
          NodeRect.Left+19+Node.Level*19+5, NodeRect.Top+1,
          theHeaderControl.Sections[0].Width+2, NodeRect.Top+16),
          NodeRect.Left+19+Node.Level*19+5, NodeRect.Top+1,
          Node.Text);
      end;

      XPos:=0;
      for i:=0 to theHeaderControl.Sections.Count-2 do
      begin
        XPos:=XPos+theHeaderControl.Sections[i].Width;

        if(TTreeView(Sender).Name='IndexTreeView')or
          (TTreeView(Sender).Name='TableIndexTreeView')then
        begin
          if(Node.Data<>nil)then
            if(i<TStringList(Node.Data).Count)then
              Sender.Canvas.TextRect(Rect(XPos+2, NodeRect.Top+1,
                XPos+theHeaderControl.Sections[i+1].Width-4, NodeRect.Top+16),
                XPos+2, NodeRect.Top+1,
                TStringList(Node.Data)[i]);
        end
        else
          Sender.Canvas.TextOut(XPos+2, NodeRect.Top+2, TDevDocNode(Node.Data).GetSubItems[i]);
      end;
    end;
  end;
end;

procedure TAdminCatalogForm.DevDocTreeViewHeaderControlSectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
begin
  DevDocTreeView.Invalidate;
end;

procedure TAdminCatalogForm.TableIndexTreeViewHeaderControlSectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
begin
  TableIndexTreeView.Invalidate;
end;

procedure TAdminCatalogForm.SchemataTreeAdvEditSeachEdChange(
  Sender: TObject);
begin
  SchemataTreeAdvEditSeachEdChange(Sender);

  //if there is no Node selected
  if(SchemataFrame.SchemaTreeView.SelectionCount=0)then
    CatalogPageControl.ActivePageIndex:=0;
end;

procedure TAdminCatalogForm.SchemataFrameSchemaTreeViewChange(
  Sender: TObject; Node: TTreeNode);
begin
  if(Node<>nil)then
    if(Node.Data<>nil)then
    begin
      if(TObject(Node.Data) is TMYX_CATALOG)then
        CatalogPageControl.ActivePage:=CatalogSheet
      else if(TObject(Node.Data) is TMYX_SCHEMA)then
      begin
        CatalogPageControl.ActivePage:=SchemaSheet;

        BuildSchemaPages(TMYX_SCHEMA(Node.Data));
      end
      else if(TObject(Node.Data) is TSchemaSubNode)then
      begin
        case TSchemaSubNode(Node.Data).GetSchemaSubNodeType of
          TSNTables:
            SchemaPageControl.ActivePage:=TablesTabSheet;
          TSNIndices:
            SchemaPageControl.ActivePage:=IndicesTabSheet;
          TSNViews:
            SchemaPageControl.ActivePage:=ViewsTabSheet;
          TSNStoredProcedures:
            SchemaPageControl.ActivePage:=StoredProcTabSheet;
          TSNEvents:
            SchemaPageControl.ActivePage:=EventsTabSheet;
          TSNDevDocs:
            SchemaPageControl.ActivePage:=DevDocTabSheet;
          TSNUsers:
            SchemaPageControl.ActivePage:=UsersTabSheet;
        end;
      end;
    end;
end;

procedure TAdminCatalogForm.FetchSchemaTableStatus(Sender: TObject);
var ptables: PMYX_SCHEMA_TABLE_STATUS;
  PMySQL: Pointer;
  SchemaName: string;
begin
  PMySQL:=myx_mysql_init;
  try
    if(myx_connect_to_instance(InstanceDM.user_connection.get_record_pointer,
      PMySQL)<>0)then
      raise EMyxError.Create('To able to connect to the server.');

    SchemaName:=TMYX_SCHEMA(TFetchDataThread(Sender).Target).schema_name;

    ptables:=myx_get_schema_table_status(PMySQL, PChar(''),
      PChar(AnsiToUtf8(SchemaName)));
    if(ptables=nil)then
      raise EMyxSQLError.Create('Error while fetching Schema Table Status.',
        myx_mysql_errno(PMySQL), myx_mysql_error(PMySQL));
    try
      CurrentTableList:=TMYX_SCHEMA_TABLE_STATUS.Create(ptables);
    finally
      myx_free_schema_table_status(ptables);
    end;
  finally
    myx_mysql_close(PMySQL);
  end;
end;

procedure TAdminCatalogForm.FetchedSchemaTableStatus(Sender: TObject);
begin
  CurrentSchema:=TMYX_SCHEMA(TFetchDataThread(Sender).Target);

  BuildSchemaPages(CurrentSchema);
end;

procedure TAdminCatalogForm.ClearControls;
begin
  //Clear Table lists
  InitControls:=True;
  try
    TablesListView.Items.BeginUpdate;
    try
      TablesListView.Clear;
      ClearTableInfos;
    finally
      TablesListView.Items.EndUpdate;
    end;

    //Clear Indices
    TableIndexTreeView.Items.BeginUpdate;
    try
      TableIndexTreeView.Items.Clear;
    finally
      TableIndexTreeView.Items.EndUpdate;
    end;

    IndexTreeView.Items.BeginUpdate;
    try
      IndexTreeView.Items.Clear;
    finally
      IndexTreeView.Items.EndUpdate;
    end;
  finally
    InitControls:=False;
  end;
end;

procedure TAdminCatalogForm.BuildSchemaPages(Schema: TMYX_SCHEMA);
var
  i, j, k: integer;
  ListItem: TListItem;
  StringList: TStringList;
  TreeNode: TTreeNode;
begin
  ClearControls;

  //if nil is passed as schema, refresh current schema
  if(Schema=nil)then
  begin
    Schema:=CurrentSchema;
    CurrentSchema:=nil;
  end;

  if(CurrentSchema<>Schema)then
  begin
    if(CurrentTableList<>nil)then
    begin
      CurrentTableList.Free;
      CurrentTableList:=nil;
    end;


    InstanceDM.FetchData(KindOfData_SchemaTableStatus,
      FetchSchemaTableStatus, FetchedSchemaTableStatus,
      Schema, 'Fetching Schema Table Status ...');

    Exit;
  end;

  TablesSchemaLbl.Caption:=Schema.schema_name;
  TablesTitleLbl.Caption:='All tables of the '+Schema.schema_name+' schema';

  IndicesSchemaLbl.Caption:=Schema.schema_name;
  IndicesTitleLbl.Caption:='All '+Schema.schema_name+' indices';
  ViewsTitleLbl.Caption:=Schema.schema_name+' views';
  StoredProcTitleLbl.Caption:=Schema.schema_name+' stored procedures';
  DevObjTitleLbl.Caption:='Developer documents stored in '+Schema.schema_name;
  UsersTitleLbl.Caption:='Users with privileges to connect to '+Schema.schema_name;

  TableNameLbl.Caption:='No table selected';

  //---------------------------------------------------------
  //Table Page

  InitControls:=True;
  TablesListView.Items.BeginUpdate;
  try
    for i:=0 to CurrentTableList.schema_tables.Count-1 do
    begin
      ListItem:=AddListViewItem(TablesListView, nil,
        CurrentTableList.schema_tables[i].table_name, 10,
        CurrentTableList.schema_tables[i]);
      ListItem.SubItems.Add(CurrentTableList.schema_tables[i].table_type);
      ListItem.SubItems.Add(CurrentTableList.schema_tables[i].row_format);
      ListItem.SubItems.Add(CurrentTableList.schema_tables[i].rows);
      ListItem.SubItems.Add(CurrentTableList.schema_tables[i].data_length);
      ListItem.SubItems.Add(CurrentTableList.schema_tables[i].update_time);
    end;

    TablesListView.Columns[0].Width:=TablesListView.Width-
      (TablesListView.Columns[1].Width+
      TablesListView.Columns[2].Width+
      TablesListView.Columns[3].Width+
      TablesListView.Columns[4].Width+
      TablesListView.Columns[5].Width+22);


  finally
    TablesListView.Items.EndUpdate;
    InitControls:=False;
  end;

  //---------------------------------------------------------
  //Index Page
  TableIndexTreeView.Items.BeginUpdate;
  try
    AddTreeViewChildNode(TableIndexTreeView, nil,
      'IndexRoot', -1);

    for k:=0 to CurrentTableList.schema_tables.Count-1 do
    begin
      for i:=0 to CurrentTableList.schema_tables[k].indexes.Count-1 do
      begin
        StringList:=TStringList.Create;

        TreeNode:=AddTreeViewChildNode(IndexTreeView, nil,
          CurrentTableList.schema_tables[k].table_name,
          12,
          StringList);


        StringList.Add(CurrentTableList.schema_tables[k].indexes[i].key_name);
        StringList.Add(CurrentTableList.schema_tables[k].indexes[i].index_type);

        if(CurrentTableList.schema_tables[k].indexes[i].is_non_unique=1)then
          StringList.Add('UNIQUE')
        else
          StringList.Add('');

        if(CurrentTableList.schema_tables[k].indexes[i].is_null_allowed=0)then
          StringList.Add('No')
        else
          StringList.Add('Yes');

        for j:=0 to CurrentTableList.schema_tables[k].indexes[i].index_columns.Count-1 do
        begin
          StringList:=TStringList.Create;

          AddTreeViewChildNode(IndexTreeView, TreeNode,
            CurrentTableList.schema_tables[k].indexes[i].index_columns[j].column_name,
            11,
            StringList);
          StringList.Add('');
          StringList.Add('');
          StringList.Add('');
          StringList.Add('');
          StringList.Add(CurrentTableList.schema_tables[k].indexes[i].index_columns[j].seq_in_index);
          StringList.Add(CurrentTableList.schema_tables[k].indexes[i].index_columns[j].collation);
        end;
      end;
    end;
  finally
    TableIndexTreeView.Items.EndUpdate;
  end;

end;

procedure TAdminCatalogForm.TablesListViewChange(Sender: TObject;
  Item: TListItem; Change: TItemChange);
var i, j: integer;
  ListItem: TListItem;
  TreeNode: TTreeNode;
  StringList: TStringList;
begin
  if(InitControls)then
    Exit;

  if(Item<>nil)then
  begin
    if(Item.Data<>nil)then
    begin
      TableNameLbl.Caption:='Table '+Item.Caption;

      ColumnListView.Items.BeginUpdate;
      try
        ColumnListView.Clear;

        for i:=0 to TMYX_TABLE_STATUS(Item.Data).columns.Count-1 do
        begin
          ListItem:=AddListViewItem(ColumnListView, nil,
            TMYX_TABLE_STATUS(Item.Data).columns[i].column_name,
            11+13*TMYX_TABLE_STATUS(Item.Data).columns[i].is_primary_key,
            TMYX_TABLE_STATUS(Item.Data).columns[i]);
          ListItem.SubItems.Add(TMYX_TABLE_STATUS(Item.Data).columns[i].column_type);
          if(TMYX_TABLE_STATUS(Item.Data).columns[i].is_null_allowed=1)then
            ListItem.SubItems.Add('')
          else
            ListItem.SubItems.Add('Not Null');
          ListItem.SubItems.Add(TMYX_TABLE_STATUS(Item.Data).columns[i].default_value);
          ListItem.SubItems.Add(TMYX_TABLE_STATUS(Item.Data).columns[i].extra);
        end;
      finally
        ColumnListView.Items.EndUpdate;
      end;

      ColumnListView.Columns[0].Width:=
        ColumnListView.Width-
        (ColumnListView.Columns[1].Width+
        ColumnListView.Columns[2].Width+
        ColumnListView.Columns[3].Width+
        ColumnListView.Columns[4].Width)-21;

      TableIndexTreeView.Items.BeginUpdate;
      try
        TableIndexTreeView.Items.Clear;

        AddTreeViewChildNode(TableIndexTreeView, nil,
          'IndexRoot', -1);

        for i:=0 to TMYX_TABLE_STATUS(Item.Data).indexes.Count-1 do
        begin
          StringList:=TStringList.Create;

          TreeNode:=AddTreeViewChildNode(TableIndexTreeView, nil,
            TMYX_TABLE_STATUS(Item.Data).indexes[i].key_name,
            12,
            StringList);

          StringList.Add(TMYX_TABLE_STATUS(Item.Data).indexes[i].index_type);

          if(TMYX_TABLE_STATUS(Item.Data).indexes[i].is_non_unique=1)then
            StringList.Add('UNIQUE')
          else
            StringList.Add('');

          if(TMYX_TABLE_STATUS(Item.Data).indexes[i].is_null_allowed=0)then
            StringList.Add('No')
          else
            StringList.Add('Yes');

          for j:=0 to TMYX_TABLE_STATUS(Item.Data).indexes[i].index_columns.Count-1 do
          begin
            StringList:=TStringList.Create;

            AddTreeViewChildNode(TableIndexTreeView, TreeNode,
              TMYX_TABLE_STATUS(Item.Data).indexes[i].index_columns[j].column_name,
              11,
              StringList);
            StringList.Add('');
            StringList.Add('');
            StringList.Add('');
            StringList.Add(TMYX_TABLE_STATUS(Item.Data).indexes[i].index_columns[j].seq_in_index);
            StringList.Add(TMYX_TABLE_STATUS(Item.Data).indexes[i].index_columns[j].collation);
          end;
        end;

        TableIndexTreeView.FullExpand;
      finally
        TableIndexTreeView.Items.EndUpdate;
      end;

      TableTypeLbl.Caption:=TMYX_TABLE_STATUS(Item.Data).table_type;
      RowFormatLbl.Caption:=TMYX_TABLE_STATUS(Item.Data).row_format;
      AutoIncLbl.Caption:=TMYX_TABLE_STATUS(Item.Data).auto_increment;
      CreateOptionsLbl.Caption:=TMYX_TABLE_STATUS(Item.Data).create_options;
      TableCommentLbl.Caption:=TMYX_TABLE_STATUS(Item.Data).comment;

      RowsLbl.Caption:=TMYX_TABLE_STATUS(Item.Data).rows;
      AvgRowLengthLbl.Caption:=TMYX_TABLE_STATUS(Item.Data).avg_row_length;
      DataLengthLbl.Caption:=TMYX_TABLE_STATUS(Item.Data).data_length;
      MaxDataLenLbl.Caption:=TMYX_TABLE_STATUS(Item.Data).max_data_length;
      IndexLenLbl.Caption:=TMYX_TABLE_STATUS(Item.Data).index_length;
      DataFreeLbl.Caption:=TMYX_TABLE_STATUS(Item.Data).data_free;

      TblCreateTimeLbl.Caption:=TMYX_TABLE_STATUS(Item.Data).create_time;
      TblUpdateTimeLbl.Caption:=TMYX_TABLE_STATUS(Item.Data).update_time;
      TblCheckTimeLbl.Caption:=TMYX_TABLE_STATUS(Item.Data).check_time;
    end
    else
      ClearTableInfos;
  end
  else
    ClearTableInfos;
end;

procedure TAdminCatalogForm.ClearTableInfos;
begin
  ColumnListView.Items.BeginUpdate;
  try
    ColumnListView.Clear;
  finally
    ColumnListView.Items.EndUpdate;
  end;

  ClearTreeView(TableIndexTreeView, myx_ndt_tobject);

  TableNameLbl.Caption:='No table selected';

  TableTypeLbl.Caption:='';
  RowFormatLbl.Caption:='';
  AutoIncLbl.Caption:='';
  CreateOptionsLbl.Caption:='';
  TableCommentLbl.Caption:='';

  RowsLbl.Caption:='';
  AvgRowLengthLbl.Caption:='';
  DataLengthLbl.Caption:='';
  MaxDataLenLbl.Caption:='';
  IndexLenLbl.Caption:='';
  DataFreeLbl.Caption:='';

  TblCreateTimeLbl.Caption:='';
  TblUpdateTimeLbl.Caption:='';
  TblCheckTimeLbl.Caption:='';
end;


procedure TAdminCatalogForm.TableIndexTreeViewChanging(Sender: TObject;
  Node: TTreeNode; var AllowChange: Boolean);
begin
  if(Sender is TTreeView)then
    if(Node=TTreeView(Sender).Items[0])then
      AllowChange:=False;
end;

procedure TAdminCatalogForm.TablesOptionsPageControlChange(
  Sender: TObject);
begin
  TablenamePnl.Parent:=TablesOptionsPageControl.ActivePage;
end;

procedure TAdminCatalogForm.IndexTreeViewHeaderControlSectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
begin
  IndexTreeView.Invalidate;
end;

procedure TAdminCatalogForm.SchemataFrameSchemaTreeViewChanging(
  Sender: TObject; Node: TTreeNode; var AllowChange: Boolean);
begin
  //Do not allow change while fetching data
  AllowChange:=(Not(KindOfData_SchemaTableStatus in InstanceDM.DataBeingFetched));
end;

procedure TAdminCatalogForm.Disconnected(var Message: TMessage);
begin
  ClearControls;

  SchemataFrame.SchemaTreeView.Items.Clear;

  DisableEnablePages(SchemaPageControl, False);
end;

procedure TAdminCatalogForm.Reconnected(var Message: TMessage);
begin
  DisableEnablePages(SchemaPageControl, True);
end;

procedure TAdminCatalogForm.CheckTablesBtnClick(Sender: TObject);
var TableList: TStringList;
  i: integer;
  Action: TableAction;
begin
  if(AdminCatalogTableCheckForm<>nil)or(CurrentSchema=nil)then
    Exit;

  if(TablesListView.SelCount=0)then
  begin
    ShowModalDialog('No table selected',
      'You have to select at least one table.',
      myx_mtInformation, 'OK');

    Exit;
  end;

  TableList:=TStringList.Create;
  try
    for i:=0 to TablesListView.Items.Count-1 do
      if(TablesListView.Items[i].Selected)then
        TableList.Add(CurrentSchema.schema_name+'.'+
          TablesListView.Items[i].Caption);

    case TButton(Sender).Tag of
      1: Action:=taOptimize;
      2: Action:=taCheck;
    else
      Action:=taRepair;
    end;

    AdminCatalogTableCheckForm:=TAdminCatalogTableCheckForm.Create(self,
      TableList.Text, InstanceDM, Action);

    AdminCatalogTableCheckForm.Show;
  finally
    TableList.Free;
  end;
end;

procedure TAdminCatalogForm.TablesListViewKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if(Key=Ord('A'))and(ssCtrl in Shift)then
    TablesListView.SelectAll;
end;

procedure TAdminCatalogForm.SchemataFrameRefreshCatalogsSchemataListMIClick(
  Sender: TObject);
begin
  SchemataFrame.RefreshCatalogsSchemataListMIClick(Sender);
end;

procedure TAdminCatalogForm.RefreshBtnClick(Sender: TObject);
begin
  if(CurrentSchema<>nil)then
    BuildSchemaPages;
end;

end.
