program MySQLAdministrator;

uses
  Forms,
  SysUtils,
  Main in 'Main.pas' {MainForm},
  ApplicationDataModule in 'ApplicationDataModule.pas' {ApplicationDM: TDataModule},
  AdditionalClasses in 'AdditionalClasses.pas',
  PNGImage in '..\..\..\mysql-gui-common\source\windows\png\pngimage.pas',
  PNGZlib in '..\..\..\mysql-gui-common\source\windows\png\pngzlib.pas',
  PNGLang in '..\..\..\mysql-gui-common\source\windows\png\pnglang.pas',
  myx_public_interface in '..\..\..\mysql-gui-common\library\public_interface\windows\myx_public_interface.pas',
  myx_admin_public_interface in '..\..\library\public_interface\windows\myx_admin_public_interface.pas',
  AdvancedEdit in '..\..\..\mysql-gui-common\source\windows\AdvancedEdit.pas' {AdvancedEditFrame: TFrame},
  AuxFuncs in '..\..\..\mysql-gui-common\source\windows\AuxFuncs.pas',
  AuxLists in '..\..\..\mysql-gui-common\source\windows\AuxLists.pas',
  ConnectToInstance in '..\..\..\mysql-gui-common\source\windows\ConnectToInstance.pas' {ConnectToInstanceForm},
  InstanceDataModule in '..\..\..\mysql-gui-common\source\windows\InstanceDataModule.pas' {InstanceDM: TDataModule},
  SchemataTreeView in '..\..\..\mysql-gui-common\source\windows\SchemataTreeView.pas' {SchemataFrame: TFrame},
  Sections in '..\..\..\mysql-gui-common\source\windows\Sections.pas',
  InstanceSections in '..\..\..\mysql-gui-common\source\windows\InstanceSections.pas',
  Translations in '..\..\..\mysql-gui-common\source\windows\Translations.pas',
  OptionsEditor in '..\..\..\mysql-gui-common\source\windows\OptionsEditor.pas' {OptionsForm},
  Options in '..\..\..\mysql-gui-common\source\windows\Options.pas',
  AdminReplication in 'AdminReplication.pas' {AdminReplicationForm},
  AdminServerInfo in 'AdminServerInfo.pas' {AdminServerInfoForm},
  AdminServiceControl in 'AdminServiceControl.pas' {AdminServiceControlForm},
  AdminUsers in 'AdminUsers.pas' {AdminUsersForm},
  AdminServerHealth in 'AdminServerHealth.pas' {AdminServerHealthForm},
  AdminServerConnections in 'AdminServerConnections.pas' {AdminServerConnectionsForm},
  AdminCatalog in 'AdminCatalog.pas' {AdminCatalogForm},
  AdminServerLogs in 'AdminServerLogs.pas' {AdminServerLogsForm},
  AdminStartupVariables in 'AdminStartupVariables.pas' {AdminStartupVariablesForm},
  AdminStartupVariablesInnoDBDatafiles in 'AdminStartupVariablesInnoDBDatafiles.pas' {AdminStartupVariablesInnoDBDatafilesForm},
  AdminStartupVariablesOptionFile in 'AdminStartupVariablesOptionFile.pas' {AdminStartupVariablesOptionFileForm},
  AdminServerHealthLineGraph in 'AdminServerHealthLineGraph.pas' {HealthLineGraphFrame: TFrame},
  AdminServerHealthBarGraph in 'AdminServerHealthBarGraph.pas' {HealthBarGraphFrame: TFrame},
  AdminRestore in 'AdminRestore.pas' {AdminRestoreForm},
  AdminBackupProgress in 'AdminBackupProgress.pas' {AdminBackupProgressForm},
  AdminBackup in 'AdminBackup.pas' {AdminBackupForm},
  AuxAdminBackupRestore in 'AuxAdminBackupRestore.pas',
  AdminCatalogTableCheck in 'AdminCatalogTableCheck.pas' {AdminCatalogTableCheckForm},
  Progress in '..\..\..\mysql-gui-common\source\windows\Progress.pas' {ProgressForm},
  About in 'About.pas' {AboutForm},
  MyxError in '..\..\..\mysql-gui-common\source\windows\MyxError.pas',
  AdminOptionPages in 'AdminOptionPages.pas' {AdminOptionPagesForm},
  AdminServerHealthGraphSettings in 'AdminServerHealthGraphSettings.pas' {AdminServerHealthGraphSettingsForm};

{$R *.res}

//Include Common Resource with PNG images, ...
{$R ..\..\..\mysql-gui-common\res\windows\mysqlcommon.res}

//Include Resource with PNG images, ...
{$R ..\..\res\windows\mysqladmin.res}

//Enable WindowsXP look'n'feel
{$R WindowsXP.res}

var ConnectionResult: integer;

procedure CheckCommandlineParameter;
var i: integer;
begin
  for i:=1 to ParamCount do
  begin
    if(CompareText(ParamStr(i), '-serviceconfig')=0)then
      ApplicationDM.Options.ShowOnlyServiceSections:=True;

    if(CompareText(Copy(ParamStr(i), 1, 13), '-installpath=')=0)then
      ApplicationDM.Options.MySQLInstallPath:=
        IncludeTrailingPathDelimiter(Copy(ParamStr(i), 14, Length(ParamStr(i))));

    if(CompareText(Copy(ParamStr(i), 1, 14), '-startsection=')=0)then
      ApplicationDM.Options.StartSection:=StrToIntDef(Copy(ParamStr(i), 15, Length(ParamStr(i))), 1);
  end;
end;


begin
  //Create Common Options
  MYXCommonOptions:=TMYXCommonOptions.Create;

  //Create Application Data Module
  ApplicationDM:=TApplicationDM.Create(nil);

  ApplicationDM.LoadOptions;

  Application.Title:='MySQL Administrator';
  Application.HelpFile:='';
  Application.Initialize;

  //Check files
  if(Not(ApplicationDM.CheckFiles))then
    Exit;

  //Load translations
  ApplicationDM.LoadTranslations;


  //Check Commandline parameter
  CheckCommandlineParameter;

  //Create Main Form
  Application.CreateForm(TMainForm, MainForm);
  if(Not(ApplicationDM.Options.ShowOnlyServiceSections))then
  begin
    ConnectionResult:=MainForm.InstanceDM.ConnectToServer;
    if(ConnectionResult=-1)then
      ApplicationDM.Options.ShowOnlyServiceSections:=True;
  end
  else
    ConnectionResult:=-1;

  if(ConnectionResult=1)or
    (ApplicationDM.Options.ShowOnlyServiceSections)then
  begin
    //Set the Caption
    if(MainForm.InstanceDM.ConnectionCaption<>'')then
      MainForm.Caption:='MySQL Administrator - '+MainForm.InstanceDM.ConnectionCaption;

    //Build the Admin Tree
    MainForm.BuildSectionTree;

    //Select first page
    if(ApplicationDM.Options.StartSection>0)and
      (ApplicationDM.Options.StartSection<=
        MainForm.SectionControls.AdminTreeView.Items.Count)then
      MainForm.SectionControls.AdminTreeView.Selected:=
        MainForm.SectionControls.AdminTreeView.Items[
        ApplicationDM.Options.StartSection-1];

    Application.Run;
  end;

  ApplicationDM.Free;
  MYXCommonOptions.Free;
end.
