/* Copyright (C) 2003 MySQL AB

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef myx_xml_aux_functions_h
#define myx_xml_aux_functions_h

#include <libxml/tree.h>

typedef char myx_bool;

char* int_to_str(int number);

char* bool_to_str(myx_bool b);

int atoi_and_free(xmlChar *string);
double atof_and_free(xmlChar *string);

xmlChar* get_failsafe_utf8(const unsigned char* latin_str);

int file_exists(const unsigned char *filename);

xmlNodePtr NewTextChild_int_content(xmlNodePtr parent,xmlNsPtr ns, const xmlChar *name, int content_int);
xmlNodePtr NewTextChild_double_content(xmlNodePtr parent,xmlNsPtr ns, const xmlChar *name, double content_double);

int get_child_count(const xmlNodePtr parent,const xmlChar *element_type_name);



#endif
