//------------------------------------------------------------------------------
// PUBLIC_INTERFACE "libmysqlx"

const
  libmysqlx_PUBLIC_INTERFACE_VERSION: Integer = 2;

type


  //----------------------------------------------------------------------------
  // Enum definitions

  PMYX_LIB_ERROR = ^MYX_LIB_ERROR;
  MYX_LIB_ERROR =
  (
    MYX_NO_ERROR = 0, MYX_ERROR_CANT_OPEN_FILE, MYX_ERROR_CANT_CONNECT_TO_INSTANCE, MYX_XML_PARSE_ERROR, 
    MYX_XML_NO_VALID_DOCUMENT, MYX_XML_EMPTY_DOCUMENT
  );

  PMYX_USER_CONNECTION_TYPE = ^MYX_USER_CONNECTION_TYPE;
  MYX_USER_CONNECTION_TYPE =
  (
    MYX_MYSQL_CONN = 0, MYX_ODBC_CONN, MYX_ORACLE_CONN, MYX_MSSQL_CONN, MYX_SQLITE_CONN
  );

  PMYX_USER_CONNECTION_STORAGE_TYPE = ^MYX_USER_CONNECTION_STORAGE_TYPE;
  MYX_USER_CONNECTION_STORAGE_TYPE =
  (
    MYX_FAVORITE_USER_CONNECTION = 1, MYX_HISTORY_USER_CONNECTION
  );

  PMYX_PASSWORD_STORAGE_TYPE = ^MYX_PASSWORD_STORAGE_TYPE;
  MYX_PASSWORD_STORAGE_TYPE =
  (
	MYX_PASSWORD_NOT_STORED = 1, MYX_PASSWORD_PLAINTEXT, MYX_PASSWORD_OBSCURED, MYX_PASSWORD_OS_SPECIFIC
  );

  PMYX_SYN_TYPE = ^MYX_SYN_TYPE;
  MYX_SYN_TYPE =
  (
  MYX_SYN_NORMAL,MYX_SYN_TABLE, MYX_SYN_COLUMN, MYX_SYN_COMMENT, MYX_SYN_STRING, MYX_SYN_SYMBOL, MYX_SYN_FUNCTION
  );


  //----------------------------------------------------------------------------
  // Struct definitions

  PMYX_USER_CONNECTION = ^MYX_USER_CONNECTION;
  PMYX_USER_CONNECTIONS = ^MYX_USER_CONNECTIONS;
  PMYX_NAME_VALUE_PAIR = ^MYX_NAME_VALUE_PAIR;
  PMYX_OPTION_GROUP = ^MYX_OPTION_GROUP;
  PMYX_APPLICATION_OPTIONS = ^MYX_APPLICATION_OPTIONS;
  PMYX_MACHINE_INFO = ^MYX_MACHINE_INFO;
  PMYX_PING_RESULT = ^MYX_PING_RESULT;
  PMYX_SCHEMA_TABLE_COLUMN = ^MYX_SCHEMA_TABLE_COLUMN;
  PMYX_TABLE_INDEX_COLUMN = ^MYX_TABLE_INDEX_COLUMN;
  PMYX_TABLE_INDEX = ^MYX_TABLE_INDEX;
  PMYX_TABLE_STATUS = ^MYX_TABLE_STATUS;
  PMYX_SCHEMA_TABLE_STATUS = ^MYX_SCHEMA_TABLE_STATUS;
  PMYX_SCHEMA_TABLE = ^MYX_SCHEMA_TABLE;
  PMYX_SCHEMA_TABLES = ^MYX_SCHEMA_TABLES;
  PMYX_SCHEMA = ^MYX_SCHEMA;
  PMYX_CATALOG = ^MYX_CATALOG;
  PMYX_CATALOGS = ^MYX_CATALOGS;
  PMYX_TRANS_TEXT = ^MYX_TRANS_TEXT;
  PMYX_TRANS_TEXTGROUP = ^MYX_TRANS_TEXTGROUP;
  PMYX_TRANS = ^MYX_TRANS;
  PMYX_SYN_WORD = ^MYX_SYN_WORD;
  PMYX_SQL_HIGHLIGHTING = ^MYX_SQL_HIGHLIGHTING;
  PMYX_SYN_SUGGESTION = ^MYX_SYN_SUGGESTION;
  PMYX_SYN_SUGGESTIONS = ^MYX_SYN_SUGGESTIONS;

  MYX_USER_CONNECTION = record
    connection_name: PChar;
    username: PChar;
    password: PChar;
    hostname: PChar;
    port: Cardinal;
    schema: PChar;
    advanced_options_num: Cardinal;
    advanced_options: PPChar;
    storage_path: PChar;
    notes: PChar;
    connection_type: myx_user_connection_type;
    storage_type: myx_user_connection_storage_type;
  end;

  MYX_USER_CONNECTIONS = record
    user_connections_num: Cardinal;
    last_connection: Integer;
    user_connections: PMYX_USER_CONNECTION;
  end;

  MYX_NAME_VALUE_PAIR = record
    name: PChar;
    value: PChar;
  end;

  MYX_OPTION_GROUP = record
    name: PChar;
    name_value_pairs_num: Cardinal;
    name_value_pairs: PMYX_NAME_VALUE_PAIR;
  end;

  MYX_APPLICATION_OPTIONS = record
    option_groups_num: Cardinal;
    option_groups: PMYX_OPTION_GROUP;
  end;

  MYX_MACHINE_INFO = record
    version: PChar;
    network_name: PChar;
    IP: PChar;
    OS: PChar;
    hardware: PChar;
  end;

  MYX_PING_RESULT = record
    round_trip_time: Integer;
    ttl: Integer;
  end;

  MYX_SCHEMA_TABLE_COLUMN = record
    column_name: PChar;
    column_type: PChar;
    default_value: PChar;
    extra: PChar;
    is_primary_key: Cardinal;
    is_null_allowed: Cardinal;
  end;

  MYX_TABLE_INDEX_COLUMN = record
    column_name: PChar;
    seq_in_index: PChar;
    collation: PChar;
  end;

  MYX_TABLE_INDEX = record
    key_name: PChar;
    index_type: PChar;
    is_null_allowed: Cardinal;
    is_non_unique: Cardinal;
    index_columns_num: Cardinal;
    index_columns: PMYX_TABLE_INDEX_COLUMN;
  end;

  MYX_TABLE_STATUS = record
    table_name: PChar;
    table_type: PChar;
    row_format: PChar;
    rows: PChar;
    avg_row_length: PChar;
    data_length: PChar;
    max_data_length: PChar;
    index_length: PChar;
    data_free: PChar;
    auto_increment: PChar;
    create_time: PChar;
    update_time: PChar;
    check_time: PChar;
    create_options: PChar;
    comment: PChar;
    indexes_num: Cardinal;
    indexes: PMYX_TABLE_INDEX;
    columns_num: Cardinal;
    columns: PMYX_SCHEMA_TABLE_COLUMN;
  end;

  MYX_SCHEMA_TABLE_STATUS = record
    schema_tables_num: Cardinal;
    schema_tables: PMYX_TABLE_STATUS;
  end;

  MYX_SCHEMA_TABLE = record
    table_name: PChar;
    columns_num: Cardinal;
    columns: PMYX_SCHEMA_TABLE_COLUMN;
  end;

  MYX_SCHEMA_TABLES = record
    schema_tables_num: Cardinal;
    schema_tables: PMYX_SCHEMA_TABLE;
  end;

  MYX_SCHEMA = record
    schema_name: PChar;
    catalog_name: PChar;
    schema_tables: PMYX_SCHEMA_TABLES;
  end;

  MYX_CATALOG = record
    catalog_name: PChar;
    schemata_num: Cardinal;
    schemata: PMYX_SCHEMA;
  end;

  MYX_CATALOGS = record
    catalogs_num: Cardinal;
    catalogs: PMYX_CATALOG;
  end;

  MYX_TRANS_TEXT = record
    id: PChar;
    trans: PChar;
  end;

  MYX_TRANS_TEXTGROUP = record
    id: PChar;
    texts_num: Cardinal;
    texts: PMYX_TRANS_TEXT;
  end;

  MYX_TRANS = record
    textgroups_general_num: Cardinal;
    textgroups_general: PMYX_TRANS_TEXTGROUP;
    current_textgroup_general: PMYX_TRANS_TEXTGROUP;
    textgroups_num: Cardinal;
    textgroups: PMYX_TRANS_TEXTGROUP;
    current_textgroup: PMYX_TRANS_TEXTGROUP;
  end;

  MYX_SYN_WORD = record
    word_begin: Integer;
    word_end: Integer;
    word_type: MYX_SYN_TYPE;
  end;

  MYX_SQL_HIGHLIGHTING = record
    line_states_size: Cardinal;
    line_states: Pointer;
    words_size: Cardinal;
    words_num: Cardinal;
    words: PMYX_SYN_WORD;
  end;

  MYX_SYN_SUGGESTION = record
    name: PChar;
    s_type: MYX_SYN_TYPE;
  end;

  MYX_SYN_SUGGESTIONS = record
    suggestions_num: Cardinal;
    suggestions: PMYX_SYN_SUGGESTION;
  end;

function myx_get_public_interface_version(): Integer; cdecl; external 'libmysqlx.dll';
procedure myx_free_lib_str(str: PChar);  cdecl; external 'libmysqlx.dll';
function myx_mysql_init(): Pointer; cdecl; external 'libmysqlx.dll';
function myx_set_my_cnf_path(path: PChar): Integer; cdecl; external 'libmysqlx.dll';
function myx_connect_to_instance(user_connection: PMYX_USER_CONNECTION; mysql: Pointer): Integer; cdecl; external 'libmysqlx.dll';
function myx_mysql_close(mysql: Pointer): Integer; cdecl; external 'libmysqlx.dll';
function myx_mysql_query(mysql: Pointer; cmd: PChar): Integer; cdecl; external 'libmysqlx.dll';
function myx_mysql_real_query(mysql: Pointer; cmd: PChar; len: Cardinal): Integer; cdecl; external 'libmysqlx.dll';
function myx_get_mysql_major_version(mysql: Pointer): Integer; cdecl; external 'libmysqlx.dll';
function myx_get_mysql_minor_version(mysql: Pointer): Integer; cdecl; external 'libmysqlx.dll';
function myx_get_server_variable(mysql: Pointer; name: PChar): PChar; cdecl; external 'libmysqlx.dll';
function myx_get_server_charset_name(mysql: Pointer): PChar; cdecl; external 'libmysqlx.dll';
function myx_convert_dbstr_utf8(mysql: Pointer; str: PChar): PChar; cdecl; external 'libmysqlx.dll';
function myx_convert_utf8_dbstr(mysql: Pointer; str: PChar): PChar; cdecl; external 'libmysqlx.dll';
function myx_mysql_errno(mysql: Pointer): Integer; cdecl; external 'libmysqlx.dll';
function myx_mysql_error(mysql: Pointer): PChar; cdecl; external 'libmysqlx.dll';
function myx_resolve_network_name(hostname: PChar): Longint; cdecl; external 'libmysqlx.dll';
function myx_ping_host(ip: Longint; ping_timeout: Integer; ping_result: PMYX_PING_RESULT): Integer; cdecl; external 'libmysqlx.dll';
function myx_is_localhost(hostname: PChar): Integer; cdecl; external 'libmysqlx.dll';
function myx_load_user_connections(filename: PChar; error_code: PMYX_LIB_ERROR): PMYX_USER_CONNECTIONS; cdecl; external 'libmysqlx.dll';
function myx_store_user_connections(user_connections: PMYX_USER_CONNECTIONS; pwd_storage_type: MYX_PASSWORD_STORAGE_TYPE; filename: PChar): Integer; cdecl; external 'libmysqlx.dll';
function myx_free_user_connections(user_connections: PMYX_USER_CONNECTIONS): Integer; cdecl; external 'libmysqlx.dll';
function myx_add_user_connection(user_connections: PMYX_USER_CONNECTIONS; new_connection: PMYX_USER_CONNECTION): Integer; cdecl; external 'libmysqlx.dll';
function myx_get_server_info(user_conn: PMYX_USER_CONNECTION; mysql: Pointer): PMYX_MACHINE_INFO; cdecl; external 'libmysqlx.dll';
function myx_get_client_info(mysql: Pointer): PMYX_MACHINE_INFO; cdecl; external 'libmysqlx.dll';
function myx_free_pc_info(machine_info: PMYX_MACHINE_INFO): Integer; cdecl; external 'libmysqlx.dll';
function myx_get_catalogs(mysql: Pointer): PMYX_CATALOGS; cdecl; external 'libmysqlx.dll';
function myx_get_schema_tables(mysql: Pointer; catalog_name: PChar; schema_name: PChar): PMYX_SCHEMA_TABLES; cdecl; external 'libmysqlx.dll';
function myx_get_schema_table_status(mysql: Pointer; catalog_name: PChar; schema_name: PChar): PMYX_SCHEMA_TABLE_STATUS; cdecl; external 'libmysqlx.dll';
function myx_free_catalogs(catalogs: PMYX_CATALOGS): Integer; cdecl; external 'libmysqlx.dll';
function myx_free_schema_tables(schema_tables: PMYX_SCHEMA_TABLES): Integer; cdecl; external 'libmysqlx.dll';
function myx_free_schema_table_status(schema_tables: PMYX_SCHEMA_TABLE_STATUS): Integer; cdecl; external 'libmysqlx.dll';
function myx_store_application_options(options: PMYX_APPLICATION_OPTIONS; filename: PChar): Integer; cdecl; external 'libmysqlx.dll';
function myx_get_application_options(filename: PChar; error_code: PMYX_LIB_ERROR): PMYX_APPLICATION_OPTIONS; cdecl; external 'libmysqlx.dll';
function myx_free_application_options(options: PMYX_APPLICATION_OPTIONS): Integer; cdecl; external 'libmysqlx.dll';
function myx_init_trans(translation_file_name: PChar; application_translation_file_name: PChar; language: PChar; error_code: PMYX_LIB_ERROR): PMYX_TRANS; cdecl; external 'libmysqlx.dll';
function myx_free_trans(trans: PMYX_TRANS): Integer; cdecl; external 'libmysqlx.dll';
function myx_t(trans: PMYX_TRANS; id_textgroup: PChar; id_text: PChar; original_text: PChar): PChar; cdecl; external 'libmysqlx.dll';
function myx_tg(trans: PMYX_TRANS; id_textgroup: PChar; id_text: PChar; original_text: PChar): PChar; cdecl; external 'libmysqlx.dll';
function myx_match_string(text: PChar; search: PChar; case_sensitive: Integer): Integer; cdecl; external 'libmysqlx.dll';
function myx_refresh_dbinfo(mysql: Pointer; _syn: Pointer): Pointer; cdecl; external 'libmysqlx.dll';
function myx_free_syn(syn: Pointer): Integer; cdecl; external 'libmysqlx.dll';
function myx_init_sql_parsing(syn: Pointer): PMYX_SQL_HIGHLIGHTING; cdecl; external 'libmysqlx.dll';
function myx_free_sql_highlighting(h: PMYX_SQL_HIGHLIGHTING): Integer; cdecl; external 'libmysqlx.dll';
function myx_highlight(sql_highlighting: PMYX_SQL_HIGHLIGHTING; text: PChar; line_no: Cardinal): Integer; cdecl; external 'libmysqlx.dll';
function myx_lookup_line(syn: Pointer; line: PChar): PMYX_SYN_SUGGESTIONS; cdecl; external 'libmysqlx.dll';
function myx_lookup_word(syn: Pointer; word_beg: PChar): PMYX_SYN_SUGGESTIONS; cdecl; external 'libmysqlx.dll';
function myx_free_syn_suggestions(s: PMYX_SYN_SUGGESTIONS): Integer; cdecl; external 'libmysqlx.dll';

